<?php

namespace Teknisa\DF\Factories;

use Doctrine\ORM\EntityManager;

class TransmissaoNfeFactory
{
    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getCorpoNotaFiscal($cdfilial, $nrlanctonf, $idorigdestnf, $identrsaid, $nrorg)
    {
        try{
            switch($idorigdestnf) {

                case "F": {
                    if($identrsaid === "S") {
                        $resultSet = $this->consultaCorpoNFFornecedor($cdfilial, $nrlanctonf, $nrorg);
                    }else{
                        $resultSet = $this->consultaCorpoNFFornecedorEntrada($cdfilial, $nrlanctonf, $nrorg);
                    }
                    break;
                }
                case "L": {
                    if($identrsaid === "S") {
                        $resultSet = $this->consultaCorpoNFFilial($cdfilial ,$nrlanctonf, $nrorg);
                    } else {
                        $resultSet = $this->consultaCorpoNFFilialEntrada($cdfilial ,$nrlanctonf, $nrorg);
                    }
                    break;
                }
                default: {
                    if($identrsaid === "S") {
                        $resultSet = $this->consultaCorpoNFCliente($cdfilial, $nrlanctonf, $nrorg);
                    }else{
                        $resultSet = $this->consultaCorpoNFClienteEntrada($cdfilial, $nrlanctonf, $nrorg);
                    }
                    break;
                }
            }

            return $resultSet;
            // Return current resultSet to get first line from array since array should return 1 row always (fetchAll)
//            return empty($resultSet) ? $resultSet : current($resultSet);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getInfoCompra($cdfilial, $nrlanctonf){
        $sql = "SELECT DSNOTAEMPENHO,
                       CDPEDIDO,
                       CDCONTRATO
                FROM INFOCOMPRANFE
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array(
            "P_NRLANCTONF"        => $nrlanctonf,
            "P_CDFILIAL"          => $cdfilial
        );
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    public function consultaCorpoNFFornecedor($cdfilial, $nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
   SELECT
    N.NRORG,
    N.CDFILIAL,
    N.CDFILIEMIT,
    F.NMFILIAL,
    N.NRLANCTONF,
    N.CDEMPRESA,
    E.CDCNAE,
    I.NMREPRINSEST,
    N.CDINSCESTA AS NRINSCESTEMIT,
 CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFE.SGESTADO END AS SGESTAEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EFI.CDESTADOIBGE END AS CDESTAIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFE.DSENDEFILI END AS DSENDEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFE.NMBAIRFILI END AS NMBAIREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFE.NRCEPFILI END AS NRCEPEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFE.NRTELEFILI END AS NRTELEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFE.NRFAXFILI END AS NRFAXEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFE.DSCOMPENDFIL END AS DSCOMPENDEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
    FO.NMRAZSOCFORN      AS NMRAZSOCCLIE,
    N.IDTPIJURNF         AS IDTPIJURCLIE,
    N.NRINSJURNF         AS NRINSJURCLIE,
    ( EF.SGESTADO ) AS SGESTACLIE,
    ESC.CDESTADOIBGE     AS CDESTAIBGECLIE,
    ( MEC.NMMUNICIPIO ) AS NMMUNICLIE,
    ( MEC.CDMUNICIBGE ) AS CDMUNIIBGECLIE,
    EF.DSENDEFORN        AS DSENDECLIE,
    FO.IDCONSFINAL,
    EF.NMBAIRFORN        AS NMBAIRCLIE,
    EF.NRCEPFORN         AS NRCEPCLIE,
    EF.NRTELEFORN        AS NRTELECLIE,
    EF.NRFAXFORN         AS NRFAXCLIE,
    FO.NRINSESTFORN      AS NRINSCESTCLIE,
    EF.DSCOMPENDFOR      AS DSCOMPENDCLI,
    PC.CDPAIS            AS CDPAISCLIE,
    PC.CDPAISBACEN       AS CDPAISBACENCLIE,
    PC.NMPAIS            AS NMPAISCLIE,
    N.NRNOTAFISC,
    NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
    N.DTENTRSAID,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                        || LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                                        )), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                                        ))) AS VRPRODUTOS,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                        || LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                                        )), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                                        ))) AS VRNOTAFISC,
    N.NRPLACAVEIC,
    N.SGUFVEIC,
    N.IDPGTOFRETE,
    N.DSQTDEVOLU,
    N.DSESPECVOLU,
    N.DSMARCAVOLU,
    N.DSNUMEVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                                         || LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'
                                                                                         )), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3),
                                                                                         '999999999999.999'))) AS VRPLIQUVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                                          || LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3)
                                                                                          , '999999999999.999')), LTRIM(TO_CHAR(ROUND
                                                                                          (VRPBRUTOVOLU, 3), '999999999999.999'))
                                                                                          ) AS VRPBRUTOVOLU,
    I.NRSERIECERTIFIC,
    NVL(N.IDORIGDESTNF, 'F') IDORIGDESTNF,
    '' AS CDCLIENTE,
    N.CDFORNECED,
    N.CDFILIRECE,
    N.IDENTRSAIDOP,
    N.CDTIPOOPER,
    N.NRACESSONFE,
    N.IDSTATUSNFE,
    N.NRNOTAFISCALELE,
    N.NRLOTENFE,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
    O.IDOPERDEVONF,
    I.IDTPIMPRESDANFE,
    NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
    S.DSSERIE            AS DSSERIE,
    N.NRINSJURTRAN,
    N.IDTPIJURTRAN,
    T.NMRAZSOCTRAN,
    T.NRINSESTTRAN,
    ( T.SGESTADO ) AS SGESTATRAN,
    ( MT.NMMUNICIPIO ) AS NMMUNITRAN,
    T.DSENDETRAN,
    NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
    N.CDINSCMUNI,
    N.CDMODDOCFISC,
    N.IDTIPOEMISNFE,
    FO.NRINSCSUFRAMAFO   AS NRINSCSUFRAMA,
    FO.NMFANTFORN        AS NMFANT,
    EM.CDESTADOIBGE      AS CDESTADOIBGEEMP,
    ME.CDMUNICIBGE       AS CDMUNICIBGEEMP,
    E.SGESTADO           AS SGESTADOEMP,
    N.CDINSCESTAST,
    EF.DSEMAILFORNNFE    AS DSEMAILDEST,
    DTHRPROTOCOLNFE,
    NRREGDPECNFE,
    DTHRREGCONTNFE,
    CDBARRACONTING,
    IDBRINDETPOPER,
    NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
    NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
    NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
    N.IDSTATUS,
    NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
    NVL(N.IDINTERMED, '0') IDINTERMED,
    N.NRCNPJINTERMED,
    N.NMCADINTERMED,
    NVL(O.IDNOTADEVO, 'N') IDNOTADEVO
    FROM
    NOTAFISCAL   N,
    TRANSPORT    T,
    FORNECEDOR   FO,
    ENDEFORN     EF,
    FILIAL       F,
    ENDEFILI EFE,
    INSCRESTAD   I,
    MUNICIPIO    MI,
    MUNICIPIO    MT,
    MUNICIPIO    MEC,
    MUNICIPIO    ME,
     MUNICIPIO MF,
    TIPOOPERAC   O,
    EMPRESA      E,
    SERIENF      S,
    ESTADO       ESE,
    ESTADO       ESC,
    ESTADO       EM,
     ESTADO EFI,
    PAIS         PE,
    PAIS         PC,
    PAIS PF,
    SERIEENTR    SE
    WHERE
    ( N.CDFILIAL = :CDFILIAL )
    AND ( N.NRLANCTONF = :NRLANCTONF )
    AND ( N.NRORG = :NRORG )
    AND ( N.IDORIGDESTNF = 'F' )
    AND ( N.IDTPIJURTRAN = T.IDTPIJURTRAN (+) )
    AND ( N.NRINSJURTRAN = T.NRINSJURTRAN (+) )
    AND ( N.NRORG = T.NRORG (+) )
    AND ( N.CDFORNECED = FO.CDFORNECED (+) )
    AND ( N.NRORG = FO.NRORG (+) )
    AND ( FO.CDFORNECED = EF.CDFORNECED (+) )
    AND ( FO.NRORG = EF.NRORG (+) )
    AND ( EF.IDTPENDEFORN = NVL(FO.IDENDEMISFOR, 'P') )
    AND (F.CDFILIAL = EFE.CDFILIAL(+))
    AND (NVL(F.IDENDEMISFIL, 'I') = EFE.IDTPENDEFILI(+))
    AND (EFE.CDPAIS = EFI.CDPAIS(+))
    AND (EFE.SGESTADO = EFI.SGESTADO(+))
    AND (EFE.CDPAIS = MF.CDPAIS(+))
    AND (EFE.SGESTADO = MF.SGESTADO(+))
    AND (EFE.CDMUNICIPIO = MF.CDMUNICIPIO(+))
    AND (EFE.CDPAIS = PF.CDPAIS(+))
    AND ( CASE N.IDENTRSAIDOP WHEN 'S' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END = F.CDFILIAL )
    AND ( N.NRORG = F.NRORG )
    AND ( N.CDEMPRESA = E.CDEMPRESA )
    AND ( N.NRORG = E.NRORG )
    AND ( I.CDEMPRESA = E.CDEMPRESA )
    AND ( I.NRORG = E.NRORG )
    AND ( N.CDINSCESTA = I.CDINSCESTA )
    AND ( N.NRORG = I.NRORG )
    AND ( E.CDPAIS = EM.CDPAIS (+) )
    AND ( E.SGESTADO = EM.SGESTADO (+) )
    AND ( E.CDPAIS = ME.CDPAIS (+) )
    AND ( E.SGESTADO = ME.SGESTADO (+) )
    AND ( E.CDMUNICIPIO = ME.CDMUNICIPIO (+) )
    AND ( I.CDPAIS = PE.CDPAIS )
    AND ( I.CDPAIS = ESE.CDPAIS (+) )
    AND ( I.SGESTADO = ESE.SGESTADO (+) )
    AND ( I.CDPAIS = MI.CDPAIS (+) )
    AND ( I.SGESTADO = MI.SGESTADO (+) )
    AND ( I.CDMUNICIPIO = MI.CDMUNICIPIO (+) )
    AND ( EF.CDPAIS = PC.CDPAIS (+) )
    AND ( EF.CDPAIS = ESC.CDPAIS (+) )
    AND ( EF.SGESTADO = ESC.SGESTADO (+) )
    AND ( EF.CDPAIS = MEC.CDPAIS (+) )
    AND ( EF.SGESTADO = MEC.SGESTADO (+) )
    AND ( EF.CDMUNICIPIO = MEC.CDMUNICIPIO (+) )
    AND ( T.CDPAIS = MT.CDPAIS (+) )
    AND ( T.SGESTADO = MT.SGESTADO (+) )
    AND ( T.CDMUNICIPIO = MT.CDMUNICIPIO (+) )
    AND ( N.CDTIPOOPER = O.CDTIPOOPER (+) )
    AND ( N.IDENTRSAIDOP = O.IDENTRSAIDOP (+) )
    AND ( N.NRORG = O.NRORG (+) )
    AND ( N.CDEMPRESA = S.CDEMPRESA (+) )
    AND ( N.CDINSCESTA = S.CDINSCESTA (+) )
    AND ( N.CDINSCMUNI = S.CDINSCMUNI (+) )
    AND ( N.CDSERIE = S.CDSERIE (+) )
    AND ( N.NRORG = S.NRORG (+) )
    AND ( N.CDSERIEENTR = SE.CDSERIEENTR (+) )
    AND ( N.NRORG = SE.NRORG (+) )
ORDER BY
    N.CDFILIAL,
    N.NRLANCTONF
SQL;
            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFFornecedorEntrada($cdfilial, $nrlanctonf, $nrorg)
    {
        try{
            $sql = "SELECT N.NRORG, N.CDFILIAL,
N.CDFILIEMIT,
F.NMFILIAL,
N.NRLANCTONF,
N.CDEMPRESA,
E.CDCNAE,
I.NMREPRINSEST,
N.CDINSCESTA AS NRINSCESTEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFE.SGESTADO END AS SGESTAEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EFI.CDESTADOIBGE END AS CDESTAIBGEEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFE.DSENDEFILI END AS DSENDEEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFE.NMBAIRFILI END AS NMBAIREMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFE.NRCEPFILI END AS NRCEPEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFE.NRTELEFILI END AS NRTELEEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFE.NRFAXFILI END AS NRFAXEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFE.DSCOMPENDFIL END AS DSCOMPENDEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
FO.NMRAZSOCFORN      AS NMRAZSOCCLIE,
N.IDTPIJURNF         AS IDTPIJURCLIE,
N.NRINSJURNF         AS NRINSJURCLIE,
( EF.SGESTADO ) AS SGESTACLIE,
ESC.CDESTADOIBGE     AS CDESTAIBGECLIE,
( MEC.NMMUNICIPIO ) AS NMMUNICLIE,
( MEC.CDMUNICIBGE ) AS CDMUNIIBGECLIE,
EF.DSENDEFORN        AS DSENDECLIE,
FO.IDCONSFINAL,
EF.NMBAIRFORN        AS NMBAIRCLIE,
EF.NRCEPFORN         AS NRCEPCLIE,
EF.NRTELEFORN        AS NRTELECLIE,
EF.NRFAXFORN         AS NRFAXCLIE,
FO.NRINSESTFORN      AS NRINSCESTCLIE,
EF.DSCOMPENDFOR      AS DSCOMPENDCLI,
PC.CDPAIS            AS CDPAISCLIE,
PC.CDPAISBACEN       AS CDPAISBACENCLIE,
PC.NMPAIS            AS NMPAISCLIE,
N.NRNOTAFISC,
NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
N.DTENTRSAID,
DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                || LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                )), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                ))) AS VRPRODUTOS,
DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                || LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                )), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                ))) AS VRNOTAFISC,
N.NRPLACAVEIC,
N.SGUFVEIC,
N.IDPGTOFRETE,
N.DSQTDEVOLU,
N.DSESPECVOLU,
N.DSMARCAVOLU,
N.DSNUMEVOLU,
DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                 || LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'
                                                                 )), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3),
                                                                 '999999999999.999'))) AS VRPLIQUVOLU,
DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                  || LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3)
                                                                  , '999999999999.999')), LTRIM(TO_CHAR(ROUND
                                                                  (VRPBRUTOVOLU, 3), '999999999999.999'))
                                                                  ) AS VRPBRUTOVOLU,
I.NRSERIECERTIFIC,
NVL(N.IDORIGDESTNF, 'F') IDORIGDESTNF,
'' AS CDCLIENTE,
N.CDFORNECED,
N.CDFILIRECE,
N.IDENTRSAIDOP,
N.CDTIPOOPER,
N.NRACESSONFE,
N.IDSTATUSNFE,
N.NRNOTAFISCALELE,
N.NRLOTENFE,
NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
O.IDOPERDEVONF,
I.IDTPIMPRESDANFE,
NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
S.DSSERIE            AS DSSERIE,
N.NRINSJURTRAN,
N.IDTPIJURTRAN,
T.NMRAZSOCTRAN,
T.NRINSESTTRAN,
( T.SGESTADO ) AS SGESTATRAN,
( MT.NMMUNICIPIO ) AS NMMUNITRAN,
T.DSENDETRAN,
NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
N.CDINSCMUNI,
N.CDMODDOCFISC,
N.IDTIPOEMISNFE,
FO.NRINSCSUFRAMAFO   AS NRINSCSUFRAMA,
FO.NMFANTFORN        AS NMFANT,
EM.CDESTADOIBGE      AS CDESTADOIBGEEMP,
ME.CDMUNICIBGE       AS CDMUNICIBGEEMP,
E.SGESTADO           AS SGESTADOEMP,
N.CDINSCESTAST,
EF.DSEMAILFORNNFE    AS DSEMAILDEST,
DTHRPROTOCOLNFE,
NRREGDPECNFE,
DTHRREGCONTNFE,
CDBARRACONTING,
IDBRINDETPOPER,
NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
N.IDSTATUS,
NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
NVL(N.IDINTERMED, '0') IDINTERMED,
N.NRCNPJINTERMED,
N.NMCADINTERMED,
NVL(O.IDNOTADEVO, 'N') IDNOTADEVO
FROM
NOTAFISCAL   N,
TRANSPORT    T,
FORNECEDOR   FO,
ENDEFORN     EF,
ENDEFILI EFE,
FILIAL       F,
INSCRESTAD   I,
MUNICIPIO    MI,
MUNICIPIO    MT,
MUNICIPIO    MEC,
MUNICIPIO    ME,
MUNICIPIO MF,
TIPOOPERAC   O,
EMPRESA      E,
SERIENF      S,
ESTADO       ESE,
ESTADO       ESC,
ESTADO       EM,
ESTADO EFI,
PAIS         PE,
PAIS         PC,
PAIS PF,
SERIEENTR    SE
WHERE
( N.CDFILIAL = :CDFILIAL )
AND ( N.NRLANCTONF = :NRLANCTONF )
AND ( N.NRORG = :NRORG )
AND ( N.IDORIGDESTNF = 'F' )
AND ( N.IDTPIJURTRAN = T.IDTPIJURTRAN (+) )
AND ( N.NRINSJURTRAN = T.NRINSJURTRAN (+) )
AND ( N.NRORG = T.NRORG (+) )
AND ( N.CDFORNECED = FO.CDFORNECED (+) )
AND ( N.NRORG = FO.NRORG (+) )
AND ( FO.CDFORNECED = EF.CDFORNECED (+) )
AND ( FO.NRORG = EF.NRORG (+) )
AND ( EF.IDTPENDEFORN = NVL(FO.IDENDEMISFOR, 'P') )
AND (NVL(F.IDENDEMISFIL, 'I') = EFE.IDTPENDEFILI(+))
AND F.CDFILIAL = EFE.CDFILIAL
AND (EFE.CDPAIS = EFI.CDPAIS(+))
AND (EFE.SGESTADO = EFI.SGESTADO(+))
AND (EFE.CDPAIS = MF.CDPAIS(+))
AND (EFE.SGESTADO = MF.SGESTADO(+))
AND (EFE.CDMUNICIPIO = MF.CDMUNICIPIO(+))
AND (EFE.CDPAIS = PF.CDPAIS(+))
AND ( CASE N.IDENTRSAIDOP WHEN 'S' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END = F.CDFILIAL )
AND ( N.NRORG = F.NRORG )
AND ( N.CDEMPRESA = E.CDEMPRESA )
AND ( N.NRORG = E.NRORG )
AND ( I.CDEMPRESA = E.CDEMPRESA )
AND ( I.NRORG = E.NRORG )
AND ( N.CDINSCESTA = I.CDINSCESTA )
AND ( N.NRORG = I.NRORG )
AND ( E.CDPAIS = EM.CDPAIS (+) )
AND ( E.SGESTADO = EM.SGESTADO (+) )
AND ( E.CDPAIS = ME.CDPAIS (+) )
AND ( E.SGESTADO = ME.SGESTADO (+) )
AND ( E.CDMUNICIPIO = ME.CDMUNICIPIO (+) )
AND ( I.CDPAIS = PE.CDPAIS )
AND ( I.CDPAIS = ESE.CDPAIS (+) )
AND ( I.SGESTADO = ESE.SGESTADO (+) )
AND ( I.CDPAIS = MI.CDPAIS (+) )
AND ( I.SGESTADO = MI.SGESTADO (+) )
AND ( I.CDMUNICIPIO = MI.CDMUNICIPIO (+) )
AND ( EF.CDPAIS = PC.CDPAIS (+) )
AND ( EF.CDPAIS = ESC.CDPAIS (+) )
AND ( EF.SGESTADO = ESC.SGESTADO (+) )
AND ( EF.CDPAIS = MEC.CDPAIS (+) )
AND ( EF.SGESTADO = MEC.SGESTADO (+) )
AND ( EF.CDMUNICIPIO = MEC.CDMUNICIPIO (+) )
AND ( T.CDPAIS = MT.CDPAIS (+) )
AND ( T.SGESTADO = MT.SGESTADO (+) )
AND ( T.CDMUNICIPIO = MT.CDMUNICIPIO (+) )
AND ( N.CDTIPOOPER = O.CDTIPOOPER (+) )
AND ( N.IDENTRSAIDOP = O.IDENTRSAIDOP (+) )
AND ( N.NRORG = O.NRORG (+) )
AND ( N.CDEMPRESA = S.CDEMPRESA (+) )
AND ( N.CDINSCESTA = S.CDINSCESTA (+) )
AND ( N.CDINSCMUNI = S.CDINSCMUNI (+) )
AND ( N.CDSERIE = S.CDSERIE (+) )
AND ( N.NRORG = S.NRORG (+) )
AND ( N.CDSERIEENTR = SE.CDSERIEENTR (+) )
AND ( N.NRORG = SE.NRORG (+) )
ORDER BY
N.CDFILIAL,
N.NRLANCTONF";


            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFFilial($cdfilial, $nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT
  N.NRORG,
  N.CDFILIAL,
  N.CDFILIEMIT,
  F.NMFILIAL,
  N.NRLANCTONF,
  N.CDEMPRESA,
  E.CDCNAE,
  I.NMREPRINSEST,
  N.CDINSCESTA AS NRINSCESTEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFEF.SGESTADO END AS SGESTAEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EFI.CDESTADOIBGE END AS CDESTAIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFEF.DSENDEFILI END AS DSENDEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFEF.NMBAIRFILI END AS NMBAIREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFEF.NRCEPFILI END AS NRCEPEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFEF.NRTELEFILI END AS NRTELEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFEF.NRFAXFILI END AS NRFAXEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFEF.DSCOMPENDFIL END AS DSCOMPENDEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
  FR.NMRAZSOCFILI AS NMRAZSOCCLIE,
  N.NRINSJURNF AS NRINSJURCLIE,
  N.IDTPIJURNF AS IDTPIJURCLIE,
  EF.SGESTADO AS SGESTACLIE,
  ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
  MEC.NMMUNICIPIO AS NMMUNICLIE,
  MEC.CDMUNICIBGE AS CDMUNIIBGECLIE,
  EF.DSENDEFILI AS DSENDECLIE,
  EF.NMBAIRFILI AS NMBAIRCLIE,
  EF.NRCEPFILI AS NRCEPCLIE,
  EF.NRTELEFILI AS NRTELECLIE,
  EF.NRFAXFILI AS NRFAXCLIE,
  FR.CDINSCESTA AS NRINSCESTCLIE,
  EF.DSCOMPENDFIL AS DSCOMPENDCLI,
  PC.CDPAIS AS CDPAISCLIE,
  PC.CDPAISBACEN AS CDPAISBACENCLIE,
  PC.NMPAIS AS NMPAISCLIE,
  NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
  N.DTENTRSAID,
  N.NRNOTAFISC,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
  N.NRPLACAVEIC,
  N.SGUFVEIC,
  N.IDPGTOFRETE,
  N.DSQTDEVOLU,
  N.DSESPECVOLU,
  N.DSMARCAVOLU,
  N.DSNUMEVOLU,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
  I.NRSERIECERTIFIC,
  NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF,
  '' AS CDCLIENTE,
  '' AS CDFORNECED,
  N.CDFILIRECE,
  N.IDENTRSAIDOP,
  N.CDTIPOOPER,
  N.NRACESSONFE,
  N.IDSTATUSNFE,
  N.NRNOTAFISCALELE,
  N.NRLOTENFE,
  NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
  O.IDOPERDEVONF,
  I.IDTPIMPRESDANFE,
  DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
  S.DSSERIE AS DSSERIE,
  N.NRINSJURTRAN,
  N.IDTPIJURTRAN,
  T.NMRAZSOCTRAN,
  T.NRINSESTTRAN,
  T.SGESTADO AS SGESTATRAN,
  MT.NMMUNICIPIO AS NMMUNITRAN,
  T.DSENDETRAN,
  NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
  NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
  N.CDINSCMUNI,
  N.CDMODDOCFISC,
  N.IDTIPOEMISNFE,
  FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
  FR.NMRAZSOCFILI AS NMFANT,
  EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
  ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
  E.SGESTADO AS SGESTADOEMP,
  N.CDINSCESTAST,
  EFE.DSEMAILEMXMLNFE AS DSEMAILDEST,
  DTHRPROTOCOLNFE,
  NRREGDPECNFE,
  DTHRREGCONTNFE,
  CDBARRACONTING,
  IDBRINDETPOPER,
  NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
  NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
  N.IDSTATUS,
  DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
  NVL(O.IDNOTADEVO, 'N') IDNOTADEVO,
  'N' AS IDCONSFINAL,
  NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
  N.DTHREMISSAOEPEC,
  'S' AS IDCONTRIBICMS,
  NVL(N.IDINTERMED, '0') IDINTERMED,
  N.NRCNPJINTERMED,
  N.NMCADINTERMED
    FROM
  NOTAFISCAL N,
  FILIAL F,
  ENDEFILI EFEF,
  PAIS PF,
  ESTADO EFI,
  MUNICIPIO MF,
  EMPRESA E,
  ESTADO EM,
  MUNICIPIO ME,
  INSCRESTAD I,
  PAIS PE,
  ESTADO ESE,
  MUNICIPIO MI,
  FILIAL FR,
  ENDEFILI EF,
  PAIS PC,
  ESTADO ESC,
  MUNICIPIO MEC,
  ENDEFILI EFE,
  TRANSPORT T,
  MUNICIPIO MT,
  TIPOOPERAC O,
  SERIENF S,
  SERIEENTR SE
WHERE (N.CDFILIAL = :CDFILIAL)
  AND (N.NRORG    = F.NRORG)
  AND (N.NRLANCTONF = :NRLANCTONF)
  AND (N.IDORIGDESTNF = 'L')
  AND (CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = F.CDFILIAL
  AND (F.CDFILIAL = EFEF.CDFILIAL(+))
  AND (NVL(F.IDENDEMISFIL, 'I') = EFEF.IDTPENDEFILI(+))
  AND (EFEF.CDPAIS = EFI.CDPAIS(+))
  AND (EFEF.SGESTADO = EFI.SGESTADO(+))
  AND (EFEF.CDPAIS = MF.CDPAIS(+))
  AND (EFEF.SGESTADO = MF.SGESTADO(+))
  AND (EFEF.CDMUNICIPIO = MF.CDMUNICIPIO(+))
  AND (EFEF.CDPAIS = PF.CDPAIS(+))
  AND (N.CDEMPRESA = E.CDEMPRESA)
  AND (N.NRORG     = E.NRORG)
  AND (E.CDPAIS = EM.CDPAIS(+))
  AND (E.SGESTADO = EM.SGESTADO(+))
  AND (E.CDPAIS = ME.CDPAIS(+))
  AND (E.SGESTADO = ME.SGESTADO(+))
  AND (E.CDMUNICIPIO = ME.CDMUNICIPIO(+))
  AND (I.CDEMPRESA = E.CDEMPRESA)
  AND (I.NRORG     = E.NRORG)    
  AND (N.CDINSCESTA = I.CDINSCESTA)
  AND (N.NRORG      = I.NRORG)  
  AND (I.CDPAIS = PE.CDPAIS(+))
  AND (I.CDPAIS = ESE.CDPAIS(+))
  AND (I.SGESTADO = ESE.SGESTADO(+))
  AND (I.CDPAIS = MI.CDPAIS(+))
  AND (I.SGESTADO = MI.SGESTADO(+))
  AND (I.CDMUNICIPIO = MI.CDMUNICIPIO(+))
  AND (N.CDFILIRECE = FR.CDFILIAL(+))
  AND (N.NRORG      = FR.NRORG(+))  
  AND (FR.CDFILIAL = EF.CDFILIAL(+))
  AND (FR.NRORG    = EF.NRORG(+))  
  AND (EF.IDTPENDEFILI = FR.IDENDEMISFIL)
  AND (EF.CDPAIS = PC.CDPAIS(+))
  AND (EF.CDPAIS = ESC.CDPAIS(+))
  AND (EF.SGESTADO = ESC.SGESTADO(+))
  AND (EF.CDPAIS = MEC.CDPAIS(+))
  AND (EF.SGESTADO = MEC.SGESTADO(+))
  AND (EF.CDMUNICIPIO = MEC.CDMUNICIPIO(+))
  AND (FR.CDFILIAL = EFE.CDFILIAL(+))
  AND (FR.NRORG    = EFE.NRORG(+))  
  AND (EFE.IDTPENDEFILI = 'P')
  AND (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+))
  AND (N.NRINSJURTRAN = T.NRINSJURTRAN(+))
  AND (N.NRORG        = T.NRORG(+))  
  AND (T.CDPAIS = MT.CDPAIS(+))
  AND (T.SGESTADO = MT.SGESTADO(+))
  AND (T.CDMUNICIPIO = MT.CDMUNICIPIO(+))
  AND (N.CDTIPOOPER = O.CDTIPOOPER(+))
  AND (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+))
  AND (N.NRORG        = O.NRORG(+))  
  AND (N.CDEMPRESA = S.CDEMPRESA(+))
  AND (N.CDINSCESTA = S.CDINSCESTA(+))
  AND (N.CDINSCMUNI = S.CDINSCMUNI(+))
  AND (N.CDSERIE = S.CDSERIE(+))
  AND (N.NRORG   = S.NRORG(+))
  AND (N.NRORG       = SE.NRORG(+))
  AND (N.CDSERIEENTR = SE.CDSERIEENTR(+))
UNION ALL
    SELECT
  N.NRORG,
  N.CDFILIAL,
  N.CDFILIEMIT,
  F.NMFILIAL,
  N.NRLANCTONF,
  N.CDEMPRESA,
  E.CDCNAE,
  I.NMREPRINSEST,
  N.CDINSCESTA AS NRINSCESTEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFEF.SGESTADO END AS SGESTAEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EFI.CDESTADOIBGE END AS CDESTAIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFEF.DSENDEFILI END AS DSENDEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFEF.NMBAIRFILI END AS NMBAIREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFEF.NRCEPFILI END AS NRCEPEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFEF.NRTELEFILI END AS NRTELEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFEF.NRFAXFILI END AS NRFAXEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFEF.DSCOMPENDFIL END AS DSCOMPENDEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
  FR.NMRAZSOCFILI AS NMRAZSOCCLIE,
  N.NRINSJURNF AS NRINSJURCLIE,
  N.IDTPIJURNF AS IDTPIJURCLIE,
  IR.SGESTADO AS SGESTACLIE,
  ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
  MEC.NMMUNICIPIO AS NMMUNICLIE,
  MEC.CDMUNICIBGE AS CDMUNIIBGECLIE,
  IR.DSENDEIEST AS DSENDECLIE,
  IR.NMBAIRIEST AS NMBAIRCLIE,
  IR.NRCEPIEST AS NRCEPCLIE,
  IR.NRTELEIEST AS NRTELECLIE,
  IR.NRFAXIEST AS NRFAXCLIE,
  FR.CDINSCESTA AS NRINSCESTCLIE,
  IR.DSCOMPENDIES AS DSCOMPENDCLI,
  PC.CDPAIS AS CDPAISCLIE,
  PC.CDPAISBACEN AS CDPAISBACENCLIE,
  PC.NMPAIS AS NMPAISCLIE,
  NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
  N.DTENTRSAID,
  N.NRNOTAFISC,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
  N.NRPLACAVEIC,
  N.SGUFVEIC,
  N.IDPGTOFRETE,
  N.DSQTDEVOLU,
  N.DSESPECVOLU,
  N.DSMARCAVOLU,
  N.DSNUMEVOLU,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
  I.NRSERIECERTIFIC,
  NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF,
  '' AS CDCLIENTE,
  '' AS CDFORNECED,
  N.CDFILIRECE,
  N.IDENTRSAIDOP,
  N.CDTIPOOPER,
  N.NRACESSONFE,
  N.IDSTATUSNFE,
  N.NRNOTAFISCALELE,
  N.NRLOTENFE,
  NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
  O.IDOPERDEVONF,
  I.IDTPIMPRESDANFE,
  DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
  S.DSSERIE AS DSSERIE,
  N.NRINSJURTRAN,
  N.IDTPIJURTRAN,
  T.NMRAZSOCTRAN,
  T.NRINSESTTRAN,
  T.SGESTADO AS SGESTATRAN,
  MT.NMMUNICIPIO AS NMMUNITRAN,
  T.DSENDETRAN,
  NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
  NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
  N.CDINSCMUNI,
  N.CDMODDOCFISC,
  N.IDTIPOEMISNFE,
  FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
  FR.NMRAZSOCFILI AS NMFANT,
  EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
  ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
  E.SGESTADO AS SGESTADOEMP,
  N.CDINSCESTAST,
  EF.DSEMAILEMXMLNFE AS DSEMAILDEST,
  DTHRPROTOCOLNFE,
  NRREGDPECNFE,
  DTHRREGCONTNFE,
  CDBARRACONTING,
  IDBRINDETPOPER,
  NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
  NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
  N.IDSTATUS,
  DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
  NVL(O.IDNOTADEVO, 'N') IDNOTADEVO,
  'N' AS IDCONSFINAL,
  NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
  N.DTHREMISSAOEPEC,
  'S' AS IDCONTRIBICMS,
  NVL(N.IDINTERMED, '0') IDINTERMED,
  N.NRCNPJINTERMED,
  N.NMCADINTERMED
    FROM
  NOTAFISCAL N,
  FILIAL F,
  ENDEFILI EFEF,
  PAIS PF,
  ESTADO EFI,
  MUNICIPIO MF,
  EMPRESA E,
  ESTADO EM,
  MUNICIPIO ME,
  INSCRESTAD I,
  PAIS PE,
  ESTADO ESE,
  MUNICIPIO MI,
  FILIAL FR,
  INSCRESTAD IR,
  PAIS PC,
  ESTADO ESC,
  MUNICIPIO MEC,
  ENDEFILI EF,
  TRANSPORT T,
  MUNICIPIO MT,
  TIPOOPERAC O,
  SERIENF S,
  SERIEENTR SE
    WHERE (N.CDFILIAL = :CDFILIAL)
  AND (N.NRLANCTONF = :NRLANCTONF)
  AND (N.NRORG = :NRORG)  
  AND (N.IDORIGDESTNF = 'L')
  AND (CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = F.CDFILIAL
  AND (N.NRORG    = F.NRORG)  
  AND (F.CDFILIAL = EFEF.CDFILIAL(+))
  AND (NVL(F.IDENDEMISFIL, 'I') = EFEF.IDTPENDEFILI(+))
  AND (EFEF.CDPAIS = EFI.CDPAIS(+))
  AND (EFEF.SGESTADO = EFI.SGESTADO(+))
  AND (EFEF.CDPAIS = MF.CDPAIS(+))
  AND (EFEF.SGESTADO = MF.SGESTADO(+))
  AND (EFEF.CDMUNICIPIO = MF.CDMUNICIPIO(+))
  AND (EFEF.CDPAIS = PF.CDPAIS(+))
  AND (N.CDEMPRESA = E.CDEMPRESA)
  AND (N.NRORG     = E.NRORG)  
  AND (E.CDPAIS = EM.CDPAIS(+))
  AND (E.SGESTADO = EM.SGESTADO(+))
  AND (E.CDPAIS = ME.CDPAIS(+))
  AND (E.SGESTADO = ME.SGESTADO(+))
  AND (E.CDMUNICIPIO = ME.CDMUNICIPIO(+))
  AND (I.CDEMPRESA = E.CDEMPRESA)
  AND (I.NRORG     = E.NRORG)  
  AND (N.CDINSCESTA = I.CDINSCESTA)
  AND (N.NRORG      = I.NRORG)  
  AND (I.CDPAIS = PE.CDPAIS(+))
  AND (I.CDPAIS = ESE.CDPAIS(+))
  AND (I.SGESTADO = ESE.SGESTADO(+))
  AND (I.CDPAIS = MI.CDPAIS(+))
  AND (I.SGESTADO = MI.SGESTADO(+))
  AND (I.CDMUNICIPIO = MI.CDMUNICIPIO(+))
  AND (N.CDFILIRECE = FR.CDFILIAL(+))
  AND (N.NRORG      = FR.NRORG(+))  
  AND (NVL(FR.IDENDEMISFIL,'I') = 'I')
  AND (IR.CDEMPRESA = FR.CDEMPRESA)
  AND (IR.CDINSCESTA = FR.CDINSCESTA)
  AND (IR.NRORG      = FR.NRORG)  
  AND (IR.CDPAIS = PC.CDPAIS(+))
  AND (IR.CDPAIS = ESC.CDPAIS(+))
  AND (IR.SGESTADO = ESC.SGESTADO(+))
  AND (IR.CDPAIS = MEC.CDPAIS(+))
  AND (IR.SGESTADO = MEC.SGESTADO(+))
  AND (IR.CDMUNICIPIO = MEC.CDMUNICIPIO(+))
  AND (FR.CDFILIAL = EF.CDFILIAL(+))
  AND (FR.NRORG    = EF.NRORG(+))  
  AND (EF.IDTPENDEFILI = 'P')
  AND (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+))
  AND (N.NRINSJURTRAN = T.NRINSJURTRAN(+))
  AND (N.NRORG        = T.NRORG(+))  
  AND (T.CDPAIS = MT.CDPAIS(+))
  AND (T.SGESTADO = MT.SGESTADO(+))
  AND (T.CDMUNICIPIO = MT.CDMUNICIPIO(+))
  AND (N.CDTIPOOPER = O.CDTIPOOPER(+))
  AND (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+))
  AND (N.NRORG        = O.NRORG(+))  
  AND (N.CDEMPRESA = S.CDEMPRESA(+))
  AND (N.CDINSCESTA = S.CDINSCESTA(+))
  AND (N.CDINSCMUNI = S.CDINSCMUNI(+))
  AND (N.CDSERIE = S.CDSERIE(+))
  AND (N.NRORG   = S.NRORG(+)) 
  AND (N.NRORG   = SE.NRORG(+))   
  AND (N.CDSERIEENTR = SE.CDSERIEENTR(+))
ORDER BY
  1, 3

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFFilialEntrada($cdfilial ,$nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT
  N.CDFILIAL,
  F.NMFILIAL,
  N.NRLANCTONF,
  N.CDEMPRESA,
  E.CDCNAE,
  I.NMREPRINSEST,
  N.CDINSCESTA AS NRINSCESTEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFEF.SGESTADO END AS SGESTAEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EFI.CDESTADOIBGE END AS CDESTAIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFEF.DSENDEFILI END AS DSENDEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFEF.NMBAIRFILI END AS NMBAIREMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFEF.NRCEPFILI END AS NRCEPEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFEF.NRTELEFILI END AS NRTELEEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFEF.NRFAXFILI END AS NRFAXEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFEF.DSCOMPENDFIL END AS DSCOMPENDEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
  CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
  FR.NMRAZSOCFILI AS NMRAZSOCCLIE,
  N.NRINSJURNF AS NRINSJURCLIE,
  N.IDTPIJURNF AS IDTPIJURCLIE,
  EF.SGESTADO AS SGESTACLIE,
  ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
  MEC.NMMUNICIPIO AS NMMUNICLIE,
  MEC.CDMUNICIBGE AS CDMUNIIBGECLIE,
  EF.DSENDEFILI AS DSENDECLIE,
  EF.NMBAIRFILI AS NMBAIRCLIE,
  EF.NRCEPFILI AS NRCEPCLIE,
  EF.NRTELEFILI AS NRTELECLIE,
  EF.NRFAXFILI AS NRFAXCLIE,
  FR.CDINSCESTA AS NRINSCESTCLIE,
  EF.DSCOMPENDFIL AS DSCOMPENDCLI,
  PC.CDPAIS AS CDPAISCLIE,
  PC.CDPAISBACEN AS CDPAISBACENCLIE,
  PC.NMPAIS AS NMPAISCLIE,
  NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
  N.DTENTRSAID,
  N.NRNOTAFISC,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
  N.NRPLACAVEIC,
  N.SGUFVEIC,
  N.IDPGTOFRETE,
  N.DSQTDEVOLU,
  N.DSESPECVOLU,
  N.DSMARCAVOLU,
  N.DSNUMEVOLU,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
  I.NRSERIECERTIFIC,
  NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF,
  '' AS CDCLIENTE,
  '' AS CDFORNECED,
  N.CDFILIRECE,
  N.CDFILIEMIT,
  N.IDENTRSAIDOP,
  N.CDTIPOOPER,
  N.NRACESSONFE,
  N.IDSTATUSNFE,
  N.NRNOTAFISCALELE,
  N.NRLOTENFE,
  NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
  O.IDOPERDEVONF,
  I.IDTPIMPRESDANFE,
  DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
  S.DSSERIE AS DSSERIE,
  N.NRINSJURTRAN,
  N.IDTPIJURTRAN,
  T.NMRAZSOCTRAN,
  T.NRINSESTTRAN,
  T.SGESTADO AS SGESTATRAN,
  MT.NMMUNICIPIO AS NMMUNITRAN,
  T.DSENDETRAN,
  NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
  NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
  N.CDINSCMUNI,
  N.CDMODDOCFISC,
  N.IDTIPOEMISNFE,
  FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
  FR.NMRAZSOCFILI AS NMFANT,
  EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
  ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
  E.SGESTADO AS SGESTADOEMP,
  N.CDINSCESTAST,
  EFE.DSEMAILEMXMLNFE AS DSEMAILDEST,
  DTHRPROTOCOLNFE,
  NRREGDPECNFE,
  DTHRREGCONTNFE,
  CDBARRACONTING,
  IDBRINDETPOPER,
  NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
  NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
  N.IDSTATUS,
  DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
  NVL(O.IDNOTADEVO, 'N') IDNOTADEVO,
  'N' AS IDCONSFINAL,
  NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
  N.DTHREMISSAOEPEC,
  'S' AS IDCONTRIBICMS,
  NVL(N.IDINTERMED, '0') IDINTERMED,
  N.NRCNPJINTERMED,
  N.NMCADINTERMED
    FROM
    NOTAFISCAL N,
    FILIAL F,
    ENDEFILI EFEF,
    PAIS PF,
    ESTADO EFI,
    MUNICIPIO MF,
    EMPRESA E,
    ESTADO EM,
    MUNICIPIO ME,
    INSCRESTAD I,
    PAIS PE,
    ESTADO ESE,
    MUNICIPIO MI,
    FILIAL FR,
    ENDEFILI EF,
    PAIS PC,
    ESTADO ESC,
    MUNICIPIO MEC,
    ENDEFILI EFE,
    TRANSPORT T,
    MUNICIPIO MT,
    TIPOOPERAC O,
    SERIENF S,
    SERIEENTR SE
    WHERE (N.CDFILIAL = :FILIAL)
    AND (N.NRLANCTONF = :LANCAMENTO)
    AND (N.IDORIGDESTNF = 'L')
    AND (CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = F.CDFILIAL
    AND (F.CDFILIAL = EFEF.CDFILIAL(+))
    AND (NVL(F.IDENDEMISFIL, 'I') = EFEF.IDTPENDEFILI(+))
    AND (EFEF.CDPAIS = EFI.CDPAIS(+))
    AND (EFEF.SGESTADO = EFI.SGESTADO(+))
    AND (EFEF.CDPAIS = MF.CDPAIS(+))
    AND (EFEF.SGESTADO = MF.SGESTADO(+))
    AND (EFEF.CDMUNICIPIO = MF.CDMUNICIPIO(+))
    AND (EFEF.CDPAIS = PF.CDPAIS(+))
    AND (N.CDEMPRESA = E.CDEMPRESA)
    AND (E.CDPAIS = EM.CDPAIS(+))
    AND (E.SGESTADO = EM.SGESTADO(+))
    AND (E.CDPAIS = ME.CDPAIS(+))
    AND (E.SGESTADO = ME.SGESTADO(+))
    AND (E.CDMUNICIPIO = ME.CDMUNICIPIO(+))
    AND (I.CDEMPRESA = E.CDEMPRESA)
    AND (N.CDINSCESTA = I.CDINSCESTA)
    AND (I.CDPAIS = PE.CDPAIS(+))
    AND (I.CDPAIS = ESE.CDPAIS(+))
    AND (I.SGESTADO = ESE.SGESTADO(+))
    AND (I.CDPAIS = MI.CDPAIS(+))
    AND (I.SGESTADO = MI.SGESTADO(+))
    AND (I.CDMUNICIPIO = MI.CDMUNICIPIO(+))
    AND (N.CDFILIEMIT = FR.CDFILIAL(+))
    AND (FR.CDFILIAL = EF.CDFILIAL(+))
    AND (EF.IDTPENDEFILI = FR.IDENDEMISFIL)
    AND (EF.CDPAIS = PC.CDPAIS(+))
    AND (EF.CDPAIS = ESC.CDPAIS(+))
    AND (EF.SGESTADO = ESC.SGESTADO(+))
    AND (EF.CDPAIS = MEC.CDPAIS(+))
    AND (EF.SGESTADO = MEC.SGESTADO(+))
    AND (EF.CDMUNICIPIO = MEC.CDMUNICIPIO(+))
    AND (FR.CDFILIAL = EFE.CDFILIAL(+))
    AND (EFE.IDTPENDEFILI = 'P')
    AND (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+))
    AND (N.NRINSJURTRAN = T.NRINSJURTRAN(+))
    AND (T.CDPAIS = MT.CDPAIS(+))
    AND (T.SGESTADO = MT.SGESTADO(+))
    AND (T.CDMUNICIPIO = MT.CDMUNICIPIO(+))
    AND (N.CDTIPOOPER = O.CDTIPOOPER(+))
    AND (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+))
    AND (N.CDEMPRESA = S.CDEMPRESA(+))
    AND (N.CDINSCESTA = S.CDINSCESTA(+))
    AND (N.CDINSCMUNI = S.CDINSCMUNI(+))
    AND (N.CDSERIE = S.CDSERIE(+))
    AND (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    UNION ALL
    SELECT
    N.CDFILIAL,
    F.NMFILIAL,
    N.NRLANCTONF,
    N.CDEMPRESA,
    E.CDCNAE,
    I.NMREPRINSEST,
    N.CDINSCESTA AS NRINSCESTEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFEF.SGESTADO END AS SGESTAEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EFI.CDESTADOIBGE END AS CDESTAIBGEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFEF.DSENDEFILI END AS DSENDEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFEF.NMBAIRFILI END AS NMBAIREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFEF.NRCEPFILI END AS NRCEPEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFEF.NRTELEFILI END AS NRTELEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFEF.NRFAXFILI END AS NRFAXEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFEF.DSCOMPENDFIL END AS DSCOMPENDEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
    FR.NMRAZSOCFILI AS NMRAZSOCCLIE,
    N.NRINSJURNF AS NRINSJURCLIE,
    N.IDTPIJURNF AS IDTPIJURCLIE,
    IR.SGESTADO AS SGESTACLIE,
    ESC.CDESTADOIBGE AS CDESTAIBGECLIE,
    MEC.NMMUNICIPIO AS NMMUNICLIE,
    MEC.CDMUNICIBGE AS CDMUNIIBGECLIE,
    IR.DSENDEIEST AS DSENDECLIE,
    IR.NMBAIRIEST AS NMBAIRCLIE,
    IR.NRCEPIEST AS NRCEPCLIE,
    IR.NRTELEIEST AS NRTELECLIE,
    IR.NRFAXIEST AS NRFAXCLIE,
    FR.CDINSCESTA AS NRINSCESTCLIE,
    IR.DSCOMPENDIES AS DSCOMPENDCLI,
    PC.CDPAIS AS CDPAISCLIE,
    PC.CDPAISBACEN AS CDPAISBACENCLIE,
    PC.NMPAIS AS NMPAISCLIE,
    NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
    N.DTENTRSAID,
    N.NRNOTAFISC,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'))) AS VRPRODUTOS,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'))) AS VRNOTAFISC,
    N.NRPLACAVEIC,
    N.SGUFVEIC,
    N.IDPGTOFRETE,
    N.DSQTDEVOLU,
    N.DSESPECVOLU,
    N.DSMARCAVOLU,
    N.DSNUMEVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'))) AS VRPLIQUVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999'))) AS VRPBRUTOVOLU,
    I.NRSERIECERTIFIC,
    NVL(N.IDORIGDESTNF , 'L') IDORIGDESTNF,
    '' AS CDCLIENTE,
    '' AS CDFORNECED,
    N.CDFILIRECE,
    N.CDFILIEMIT,
    N.IDENTRSAIDOP,
    N.CDTIPOOPER,
    N.NRACESSONFE,
    N.IDSTATUSNFE,
    N.NRNOTAFISCALELE,
    N.NRLOTENFE,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
    O.IDOPERDEVONF,
    I.IDTPIMPRESDANFE,
    DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
    S.DSSERIE AS DSSERIE,
    N.NRINSJURTRAN,
    N.IDTPIJURTRAN,
    T.NMRAZSOCTRAN,
    T.NRINSESTTRAN,
    T.SGESTADO AS SGESTATRAN,
    MT.NMMUNICIPIO AS NMMUNITRAN,
    T.DSENDETRAN,
    NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
    N.CDINSCMUNI,
    N.CDMODDOCFISC,
    N.IDTIPOEMISNFE,
    FR.NRINSCSUFRAMAFI AS NRINSCSUFRAMA,
    FR.NMRAZSOCFILI AS NMFANT,
    EM.CDESTADOIBGE AS CDESTADOIBGEEMP,
    ME.CDMUNICIBGE AS CDMUNICIBGEEMP,
    E.SGESTADO AS SGESTADOEMP,
    N.CDINSCESTAST,
    EF.DSEMAILEMXMLNFE AS DSEMAILDEST,
    DTHRPROTOCOLNFE,
    NRREGDPECNFE,
    DTHRREGCONTNFE,
    CDBARRACONTING,
    IDBRINDETPOPER,
    NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
    NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
    N.IDSTATUS,
    DECODE(N.IDENTRSAIDOP, 'S', S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
    NVL(O.IDNOTADEVO, 'N') IDNOTADEVO,
    'N' AS IDCONSFINAL,
    NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
    N.DTHREMISSAOEPEC,
    'S' AS IDCONTRIBICMS,
    NVL(N.IDINTERMED, '0') IDINTERMED,
    N.NRCNPJINTERMED,
    N.NMCADINTERMED
    FROM
    NOTAFISCAL N,
    FILIAL F,
    ENDEFILI EFEF,
    PAIS PF,
    ESTADO EFI,
    MUNICIPIO MF,
    EMPRESA E,
    ESTADO EM,
    MUNICIPIO ME,
    INSCRESTAD I,
    PAIS PE,
    ESTADO ESE,
    MUNICIPIO MI,
    FILIAL FR,
    INSCRESTAD IR,
    PAIS PC,
    ESTADO ESC,
    MUNICIPIO MEC,
    ENDEFILI EF,
    TRANSPORT T,
    MUNICIPIO MT,
    TIPOOPERAC O,
    SERIENF S,
    SERIEENTR SE
    WHERE (N.CDFILIAL = :FILIAL)
    AND (N.NRLANCTONF = :LANCAMENTO)
    AND (N.IDORIGDESTNF = 'L')
    AND (CASE N.IDENTRSAIDOP WHEN 'E' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = F.CDFILIAL
    AND (F.CDFILIAL = EFEF.CDFILIAL(+))
    AND (NVL(F.IDENDEMISFIL, 'I') = EFEF.IDTPENDEFILI(+))
    AND (EFEF.CDPAIS = EFI.CDPAIS(+))
    AND (EFEF.SGESTADO = EFI.SGESTADO(+))
    AND (EFEF.CDPAIS = MF.CDPAIS(+))
    AND (EFEF.SGESTADO = MF.SGESTADO(+))
    AND (EFEF.CDMUNICIPIO = MF.CDMUNICIPIO(+))
    AND (EFEF.CDPAIS = PF.CDPAIS(+))
    AND (N.CDEMPRESA = E.CDEMPRESA)
    AND (E.CDPAIS = EM.CDPAIS(+))
    AND (E.SGESTADO = EM.SGESTADO(+))
    AND (E.CDPAIS = ME.CDPAIS(+))
    AND (E.SGESTADO = ME.SGESTADO(+))
    AND (E.CDMUNICIPIO = ME.CDMUNICIPIO(+))
    AND (I.CDEMPRESA = E.CDEMPRESA)
    AND (N.CDINSCESTA = I.CDINSCESTA)
    AND (I.CDPAIS = PE.CDPAIS(+))
    AND (I.CDPAIS = ESE.CDPAIS(+))
    AND (I.SGESTADO = ESE.SGESTADO(+))
    AND (I.CDPAIS = MI.CDPAIS(+))
    AND (I.SGESTADO = MI.SGESTADO(+))
    AND (I.CDMUNICIPIO = MI.CDMUNICIPIO(+))
    AND (N.CDFILIEMIT = FR.CDFILIAL(+))
    AND (NVL(FR.IDENDEMISFIL,'I') = 'I')
    AND (IR.CDEMPRESA = FR.CDEMPRESA)
    AND (IR.CDINSCESTA = FR.CDINSCESTA)
    AND (IR.CDPAIS = PC.CDPAIS(+))
    AND (IR.CDPAIS = ESC.CDPAIS(+))
    AND (IR.SGESTADO = ESC.SGESTADO(+))
    AND (IR.CDPAIS = MEC.CDPAIS(+))
    AND (IR.SGESTADO = MEC.SGESTADO(+))
    AND (IR.CDMUNICIPIO = MEC.CDMUNICIPIO(+))
    AND (FR.CDFILIAL = EF.CDFILIAL(+))
    AND (EF.IDTPENDEFILI = 'P')
    AND (N.IDTPIJURTRAN = T.IDTPIJURTRAN(+))
    AND (N.NRINSJURTRAN = T.NRINSJURTRAN(+))
    AND (T.CDPAIS = MT.CDPAIS(+))
    AND (T.SGESTADO = MT.SGESTADO(+))
    AND (T.CDMUNICIPIO = MT.CDMUNICIPIO(+))
    AND (N.CDTIPOOPER = O.CDTIPOOPER(+))
    AND (N.IDENTRSAIDOP = O.IDENTRSAIDOP(+))
    AND (N.CDEMPRESA = S.CDEMPRESA(+))
    AND (N.CDINSCESTA = S.CDINSCESTA(+))
    AND (N.CDINSCMUNI = S.CDINSCMUNI(+))
    AND (N.CDSERIE = S.CDSERIE(+))
    AND (N.CDSERIEENTR = SE.CDSERIEENTR(+))
    ORDER BY
    1,3

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFCliente($cdfilial ,$nrlanctonf, $nrorg)
    {
        
        try{
            $sql = <<<SQL
    SELECT
    N.NRORG,
    N.CDFILIAL,
    N.CDFILIEMIT,
    F.NMFILIAL,
    N.NRLANCTONF,
    N.NRNOTAFISCALELE,
    N.CDEMPRESA,
    E.CDCNAE,
    I.NMREPRINSEST,
    N.CDINSCESTA AS NRINSCESTEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFE.SGESTADO END AS SGESTAEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EF.CDESTADOIBGE END AS CDESTAIBGEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFE.DSENDEFILI END AS DSENDEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFE.NMBAIRFILI END AS NMBAIREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFE.NRCEPFILI END AS NRCEPEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFE.NRTELEFILI END AS NRTELEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFE.NRFAXFILI END AS NRFAXEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFE.DSCOMPENDFIL END AS DSCOMPENDEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
    C.NMRAZSOCCLIE,
    C.IDCONSFINAL,
    N.NRINSJURNF        AS NRINSJURCLIE,
    N.IDTPIJURNF        AS IDTPIJURCLIE,
    ( EC.SGESTADO ) AS SGESTACLIE,
    ESC.CDESTADOIBGE    AS CDESTAIBGECLIE,
    ( MEC.NMMUNICIPIO ) AS NMMUNICLIE,
    ( MEC.CDMUNICIBGE ) AS CDMUNIIBGECLIE,
    EC.DSENDECLIE,
    EC.NMBAIRCLIE,
    EC.NRCEPCLIE,
    EC.NRTELECLIE,
    EC.NRFAXCLIE,
    C.NRINSESTCLIE      AS NRINSCESTCLIE,
    EC.DSCOMPENDCLI,
    PC.CDPAIS           AS CDPAISCLIE,
    PC.CDPAISBACEN      AS CDPAISBACENCLIE,
    PC.NMPAIS           AS NMPAISCLIE,
    N.NRNOTAFISC,
    NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
    N.DTENTRSAID,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                        || LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                                        )), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                                        ))) AS VRPRODUTOS,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                        || LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                                        )), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                                        ))) AS VRNOTAFISC,
    N.NRPLACAVEIC,
    N.SGUFVEIC,
    N.IDPGTOFRETE,
    N.DSQTDEVOLU,
    N.DSESPECVOLU,
    N.DSMARCAVOLU,
    N.DSNUMEVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                                         || LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'
                                                                                         )), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3),
                                                                                         '999999999999.999'))) AS VRPLIQUVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                                          || LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3)
                                                                                          , '999999999999.999')), LTRIM(TO_CHAR(ROUND
                                                                                          (VRPBRUTOVOLU, 3), '999999999999.999'))
                                                                                          ) AS VRPBRUTOVOLU,
    I.NRSERIECERTIFIC,
    NVL(N.IDORIGDESTNF, 'C') IDORIGDESTNF,
    N.CDCLIENTE,
    '' AS CDFORNECED,
    N.CDFILIRECE,
    N.IDENTRSAIDOP,
    N.CDTIPOOPER,
    N.NRACESSONFE,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
    O.IDOPERDEVONF,
    I.IDTPIMPRESDANFE,
    NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
    S.DSSERIE           AS DSSERIE,
    N.NRINSJURTRAN,
    N.IDTPIJURTRAN,
    T.NMRAZSOCTRAN,
    T.NRINSESTTRAN,
    ( T.SGESTADO ) AS SGESTATRAN,
    ( MT.NMMUNICIPIO ) AS NMMUNITRAN,
    T.DSENDETRAN,
    NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
    N.CDINSCMUNI,
    N.CDMODDOCFISC,
    N.IDTIPOEMISNFE,
    C.NRINSCSUFRAMACL   AS NRINSCSUFRAMA,
    C.NMFANTCLIE        AS NMFANT,
    EM.CDESTADOIBGE     AS CDESTADOIBGEEMP,
    ME.CDMUNICIBGE      AS CDMUNICIBGEEMP,
    E.SGESTADO          AS SGESTADOEMP,
    N.CDINSCESTAST,
    EC.DSEMAILCLIENFE   AS DSEMAILDEST,
    DTHRPROTOCOLNFE,
    NRREGDPECNFE,
    DTHRREGCONTNFE,
    CDBARRACONTING,
    IDBRINDETPOPER,
    NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
    NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
    NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
    N.IDSTATUS,
    NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
    NVL(N.IDINTERMED, '0') IDINTERMED,
    N.NRCNPJINTERMED,
    N.NMCADINTERMED,
    NVL(O.IDNOTADEVO, 'N') IDNOTADEVO
    FROM
    NOTAFISCAL   N,
    TRANSPORT    T,
    CLIENTE      C,
    ENDECLIE     EC,
    FILIAL       F,
    INSCRESTAD   I,
    MUNICIPIO    MI,
    MUNICIPIO    MT,
    MUNICIPIO    MEC,
    MUNICIPIO    ME,
    MUNICIPIO    MF,
    TIPOOPERAC   O,
    EMPRESA      E,
    SERIENF      S,
    ESTADO       ESE,
    ESTADO       ESC,
    ESTADO       EM,
    ESTADO       EF,
    PAIS         PE,
    PAIS         PF,
    PAIS         PC,
    SERIEENTR    SE,
    ENDEFILI     EFE
    WHERE
    ( N.CDFILIAL = :CDFILIAL )
    AND ( N.NRLANCTONF = :NRLANCTONF )
    AND ( N.NRORG = :NRORG )
    AND ( N.CDCLIENTE = C.CDCLIENTE (+) )
    AND ( N.NRORG = C.NRORG (+) )
    AND ( C.CDCLIENTE = EC.CDCLIENTE (+) )
    AND ( C.NRORG = EC.NRORG (+) )
    AND ( F.CDFILIAL = EFE.CDFILIAL (+) )
    AND ( NVL(F.IDENDEMISFIL, 'I') = EFE.IDTPENDEFILI (+) )
    AND ( EFE.CDPAIS = EF.CDPAIS (+) )
    AND ( EFE.SGESTADO = EF.SGESTADO (+) )
    AND ( EFE.CDPAIS = MF.CDPAIS (+) )
    AND ( EFE.SGESTADO = MF.SGESTADO (+) )
    AND ( EFE.CDMUNICIPIO = MF.CDMUNICIPIO (+) )
    AND ( EC.IDTPENDECLIE = NVL(C.IDENDEMISCLI, 'P') )
    AND ( ( N.IDORIGDESTNF IS NULL )
          OR ( N.IDORIGDESTNF = 'C' ) )
    AND ( N.IDTPIJURTRAN = T.IDTPIJURTRAN (+) )
    AND ( N.NRINSJURTRAN = T.NRINSJURTRAN (+) )
    AND ( N.NRORG = T.NRORG (+) )
    AND ( CASE N.IDENTRSAIDOP WHEN 'S' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END = F.CDFILIAL )
    AND ( N.NRORG = F.NRORG )
    AND ( N.CDEMPRESA = E.CDEMPRESA )
    AND ( N.NRORG = E.NRORG )
    AND ( I.CDEMPRESA = E.CDEMPRESA )
    AND ( I.NRORG = E.NRORG )
    AND ( N.CDINSCESTA = I.CDINSCESTA )
    AND ( N.NRORG = I.NRORG )
    AND ( E.CDPAIS = EM.CDPAIS (+) )
    AND ( E.SGESTADO = EM.SGESTADO (+) )
    AND ( E.CDPAIS = ME.CDPAIS (+) )
    AND ( E.SGESTADO = ME.SGESTADO (+) )
    AND ( E.CDMUNICIPIO = ME.CDMUNICIPIO (+) )
     AND (EFE.CDPAIS = PF.CDPAIS(+))
    AND ( I.CDPAIS = PE.CDPAIS (+) )
    AND ( I.CDPAIS = ESE.CDPAIS (+) )
    AND ( I.SGESTADO = ESE.SGESTADO (+) )
    AND ( I.CDPAIS = MI.CDPAIS (+) )
    AND ( I.SGESTADO = MI.SGESTADO (+) )
    AND ( I.CDMUNICIPIO = MI.CDMUNICIPIO (+) )
    AND ( EC.CDPAIS = PC.CDPAIS (+) )
    AND ( EC.CDPAIS = ESC.CDPAIS (+) )
    AND ( EC.SGESTADO = ESC.SGESTADO (+) )
    AND ( EC.CDPAIS = MEC.CDPAIS (+) )
    AND ( EC.SGESTADO = MEC.SGESTADO (+) )
    AND ( EC.CDMUNICIPIO = MEC.CDMUNICIPIO (+) )
    AND ( T.CDPAIS = MT.CDPAIS (+) )
    AND ( T.SGESTADO = MT.SGESTADO (+) )
    AND ( T.CDMUNICIPIO = MT.CDMUNICIPIO (+) )
    AND ( N.CDTIPOOPER = O.CDTIPOOPER (+) )
    AND ( N.IDENTRSAIDOP = O.IDENTRSAIDOP (+) )
    AND ( N.NRORG = O.NRORG (+) )
    AND ( N.CDEMPRESA = S.CDEMPRESA (+) )
    AND ( N.CDINSCESTA = S.CDINSCESTA (+) )
    AND ( N.CDINSCMUNI = S.CDINSCMUNI (+) )
    AND ( N.CDSERIE = S.CDSERIE (+) )
    AND ( N.NRORG = S.NRORG (+) )
    AND ( N.NRORG = SE.NRORG (+) )
    AND ( N.CDSERIEENTR = SE.CDSERIEENTR (+) )
ORDER BY
    CDFILIAL,
    NRLANCTONF

SQL;

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function consultaCorpoNFClienteEntrada($cdfilial ,$nrlanctonf, $nrorg)
    {
        try{
            $sql = <<<SQL
    SELECT
    N.NRORG,
    N.CDFILIAL,
    N.CDFILIEMIT,
    F.NMFILIAL,
    N.NRLANCTONF,
    N.NRNOTAFISCALELE,
    N.CDEMPRESA,
    E.CDCNAE,
    I.NMREPRINSEST,
    N.CDINSCESTA AS NRINSCESTEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN E.NMRAZSOCEMPR ELSE F.NMRAZSOCFILI END AS NMRAZSOCEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRINSJURIEST ELSE F.NRINSJURFILI END AS NRINSJUREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.IDTPIJURIEST ELSE F.IDTPIJURFILI END AS IDTPIJUREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.SGESTADO ELSE EFE.SGESTADO END AS SGESTAEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN ESE.CDESTADOIBGE ELSE EF.CDESTADOIBGE END AS CDESTAIBGEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN MI.NMMUNICIPIO ELSE MF.NMMUNICIPIO END AS NMMUNIEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN MI.CDMUNICIBGE ELSE MF.CDMUNICIBGE END AS CDMUNIIBGEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSENDEIEST ELSE EFE.DSENDEFILI END AS DSENDEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NMBAIRIEST ELSE EFE.NMBAIRFILI END AS NMBAIREMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRCEPIEST ELSE EFE.NRCEPFILI END AS NRCEPEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRTELEIEST ELSE EFE.NRTELEFILI END AS NRTELEEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.NRFAXIEST ELSE EFE.NRFAXFILI END AS NRFAXEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN I.DSCOMPENDIES ELSE EFE.DSCOMPENDFIL END AS DSCOMPENDEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAIS ELSE PF.CDPAIS END AS CDPAISEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.CDPAISBACEN ELSE PF.CDPAISBACEN END AS CDPAISBACENEMIT,
    CASE F.IDENDEMISFIL WHEN 'I' THEN PE.NMPAIS ELSE PF.NMPAIS END AS NMPAISEMIT,
    C.NMRAZSOCCLIE,
    C.IDCONSFINAL,
    N.NRINSJURNF        AS NRINSJURCLIE,
    N.IDTPIJURNF        AS IDTPIJURCLIE,
    ( EC.SGESTADO ) AS SGESTACLIE,
    ESC.CDESTADOIBGE    AS CDESTAIBGECLIE,
    ( MEC.NMMUNICIPIO ) AS NMMUNICLIE,
    ( MEC.CDMUNICIBGE ) AS CDMUNIIBGECLIE,
    EC.DSENDECLIE,
    EC.NMBAIRCLIE,
    EC.NRCEPCLIE,
    EC.NRTELECLIE,
    EC.NRFAXCLIE,
    C.NRINSESTCLIE      AS NRINSCESTCLIE,
    EC.DSCOMPENDCLI,
    PC.CDPAIS           AS CDPAISCLIE,
    PC.CDPAISBACEN      AS CDPAISBACENCLIE,
    PC.NMPAIS           AS NMPAISCLIE,
    N.NRNOTAFISC,
    NVL(N.DTEMISSAO, N.DTENTRSAID) DTEMISSAO,
    N.DTENTRSAID,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                            || LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                            )), LTRIM(TO_CHAR(ROUND(VRPRODUTOS, 2), '9999999999999.99'
                                                                            ))) AS VRPRODUTOS,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                            || LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                            )), LTRIM(TO_CHAR(ROUND(VRNOTAFISC, 2), '9999999999999.99'
                                                                            ))) AS VRNOTAFISC,
    N.NRPLACAVEIC,
    N.SGUFVEIC,
    N.IDPGTOFRETE,
    N.DSQTDEVOLU,
    N.DSESPECVOLU,
    N.DSMARCAVOLU,
    N.DSNUMEVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                             || LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3), '999999999999.999'
                                                                             )), LTRIM(TO_CHAR(ROUND(VRPLIQUVOLU, 3),
                                                                             '999999999999.999'))) AS VRPLIQUVOLU,
    DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3), '999999999999.999')), 1, 1), '.', '0'
                                                                              || LTRIM(TO_CHAR(ROUND(VRPBRUTOVOLU, 3)
                                                                              , '999999999999.999')), LTRIM(TO_CHAR(ROUND
                                                                              (VRPBRUTOVOLU, 3), '999999999999.999'))
                                                                              ) AS VRPBRUTOVOLU,
    I.NRSERIECERTIFIC,
    NVL(N.IDORIGDESTNF, 'C') IDORIGDESTNF,
    N.CDCLIENTE,
    '' AS CDFORNECED,
    N.CDFILIRECE,
    N.IDENTRSAIDOP,
    N.CDTIPOOPER,
    N.NRACESSONFE,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS NMTIPOOPER,
    O.IDOPERDEVONF,
    I.IDTPIMPRESDANFE,
    NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE) AS CDSERIE,
    S.DSSERIE           AS DSSERIE,
    N.NRINSJURTRAN,
    N.IDTPIJURTRAN,
    T.NMRAZSOCTRAN,
    T.NRINSESTTRAN,
    ( T.SGESTADO ) AS SGESTATRAN,
    ( MT.NMMUNICIPIO ) AS NMMUNITRAN,
    T.DSENDETRAN,
    NVL(N.CDCFOPINFUSU, N.CDFISOPENTF) AS CDFISOPENTF,
    NVL(N.DSCFOPINFUSU, N.DSCDFISOPENF) AS DSCDFISOPENF,
    N.CDINSCMUNI,
    N.CDMODDOCFISC,
    N.IDTIPOEMISNFE,
    C.NRINSCSUFRAMACL   AS NRINSCSUFRAMA,
    C.NMFANTCLIE        AS NMFANT,
    EM.CDESTADOIBGE     AS CDESTADOIBGEEMP,
    ME.CDMUNICIBGE      AS CDMUNICIBGEEMP,
    E.SGESTADO          AS SGESTADOEMP,
    N.CDINSCESTAST,
    EC.DSEMAILCLIENFE   AS DSEMAILDEST,
    DTHRPROTOCOLNFE,
    NRREGDPECNFE,
    DTHRREGCONTNFE,
    CDBARRACONTING,
    IDBRINDETPOPER,
    NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN) AS CDSERIESCAN,
    NVL(O.IDNFESTCANC, 'N') IDNFESTCANC,
    NVL(O.IDNFAJUSTE, 'N') IDNFAJUSTE,
    N.IDSTATUS,
    NVL(N.IDPRESENCIAL, '9') IDPRESENCIAL,
    NVL(N.IDINTERMED, '0') IDINTERMED,
    N.NRCNPJINTERMED,
    N.NMCADINTERMED,
    NVL(O.IDNOTADEVO, 'N') IDNOTADEVO
    FROM
    NOTAFISCAL   N,
    TRANSPORT    T,
    CLIENTE      C,
    ENDECLIE     EC,
    FILIAL       F,
    ENDEFILI EFE,
    INSCRESTAD   I,
    MUNICIPIO    MI,
    MUNICIPIO    MT,
    MUNICIPIO    MEC,
    MUNICIPIO    ME,
    MUNICIPIO MF,
    TIPOOPERAC   O,
    EMPRESA      E,
    SERIENF      S,
    ESTADO       ESE,
    ESTADO       ESC,
    ESTADO       EM,
    ESTADO EF,
    PAIS         PE,
    PAIS         PC,
    PAIS PF,
    SERIEENTR    SE
    WHERE
    ( N.CDFILIAL = :CDFILIAL )
    AND ( N.NRLANCTONF = :NRLANCTONF )
    AND ( N.NRORG = :NRORG )
    AND ( N.CDCLIENTE = C.CDCLIENTE (+) )
    AND ( N.NRORG = C.NRORG (+) )
    AND ( C.CDCLIENTE = EC.CDCLIENTE (+) )
    AND ( C.NRORG = EC.NRORG (+) )
    AND ( EC.IDTPENDECLIE = NVL(C.IDENDEMISCLI, 'P') )
    AND ( ( N.IDORIGDESTNF IS NULL )
    OR ( N.IDORIGDESTNF = 'C' ) )
    AND (NVL(F.IDENDEMISFIL, 'I') = EFE.IDTPENDEFILI(+))
    AND (EFE.CDPAIS = EF.CDPAIS(+))
    AND (EFE.SGESTADO = EF.SGESTADO(+))
    AND (EFE.CDPAIS = MF.CDPAIS(+))
    AND (EFE.SGESTADO = MF.SGESTADO(+))
    AND (EFE.CDMUNICIPIO = MF.CDMUNICIPIO(+))
    AND (EFE.CDPAIS = PF.CDPAIS(+))
    AND ( N.IDTPIJURTRAN = T.IDTPIJURTRAN (+) )
    AND ( N.NRINSJURTRAN = T.NRINSJURTRAN (+) )
    AND ( N.NRORG = T.NRORG (+) )
    AND ( CASE N.IDENTRSAIDOP WHEN 'S' THEN N.CDFILIEMIT ELSE N.CDFILIRECE END = F.CDFILIAL )
    AND ( N.NRORG = F.NRORG )
    AND ( N.CDEMPRESA = E.CDEMPRESA )
    AND ( N.NRORG = E.NRORG )
    AND ( I.CDEMPRESA = E.CDEMPRESA )
    AND ( I.NRORG = E.NRORG )
    AND ( N.CDINSCESTA = I.CDINSCESTA )
    AND ( N.NRORG = I.NRORG )
    AND ( E.CDPAIS = EM.CDPAIS (+) )
    AND ( E.SGESTADO = EM.SGESTADO (+) )
    AND ( E.CDPAIS = ME.CDPAIS (+) )
    AND ( E.SGESTADO = ME.SGESTADO (+) )
    AND ( E.CDMUNICIPIO = ME.CDMUNICIPIO (+) )
    AND ( I.CDPAIS = PE.CDPAIS (+) )
    AND ( I.CDPAIS = ESE.CDPAIS (+) )
    AND ( I.SGESTADO = ESE.SGESTADO (+) )
    AND ( I.CDPAIS = MI.CDPAIS (+) )
    AND ( I.SGESTADO = MI.SGESTADO (+) )
    AND ( I.CDMUNICIPIO = MI.CDMUNICIPIO (+) )
    AND ( EC.CDPAIS = PC.CDPAIS (+) )
    AND ( EC.CDPAIS = ESC.CDPAIS (+) )
    AND ( EC.SGESTADO = ESC.SGESTADO (+) )
    AND ( EC.CDPAIS = MEC.CDPAIS (+) )
    AND ( EC.SGESTADO = MEC.SGESTADO (+) )
    AND ( EC.CDMUNICIPIO = MEC.CDMUNICIPIO (+) )
    AND ( T.CDPAIS = MT.CDPAIS (+) )
    AND ( T.SGESTADO = MT.SGESTADO (+) )
    AND ( T.CDMUNICIPIO = MT.CDMUNICIPIO (+) )
    AND ( N.CDTIPOOPER = O.CDTIPOOPER (+) )
    AND ( N.IDENTRSAIDOP = O.IDENTRSAIDOP (+) )
    AND ( N.NRORG = O.NRORG (+) )
    AND ( N.CDEMPRESA = S.CDEMPRESA (+) )
    AND ( N.CDINSCESTA = S.CDINSCESTA (+) )
    AND ( N.CDINSCMUNI = S.CDINSCMUNI (+) )
    AND ( N.CDSERIE = S.CDSERIE (+) )
    AND ( N.NRORG = S.NRORG (+) )
    AND ( N.NRORG = SE.NRORG (+) )
    AND ( N.CDSERIEENTR = SE.CDSERIEENTR (+) )
    ORDER BY
    CDFILIAL,
    NRLANCTONF

SQL;
            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function getMaxCDFISOPEITEM($filial, $lancamento, $nrorg){
        $sql = <<<SQL
        SELECT MAX(CDFISOPEITEM)
          FROM ITEMPRODUTO
         WHERE CDFILIAL   = :P_CDFILIAL
           AND NRLANCTONF = :P_NRLANCTONF
           AND NRORG      = :P_NRORG

SQL;
        $params = array(
            "P_CDFILIAL" => $filial,
            "P_NRLANCTONF" => $lancamento,
            "P_NRORG" => $nrorg
        );

        try{
            return $this->entityManager->getConnection()->fetchColumn($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function consultaItemProdutoImpostoNFE($cdfilial, $nrlanctonf, $cdimpostonfe, $nrorg)
    {
        $sql = <<<SQL
        SELECT ITEMPROIMPOS.CDFILIAL,
          ITEMPROIMPOS.NRLANCTONF,
          ITEMPROIMPOS.CDIMPOSTO,
          IMPOSTO.CDIMPOSTONFE
          FROM ITEMPROIMPOS
          JOIN IMPOSTO
            ON ITEMPROIMPOS.CDIMPOSTO = IMPOSTO.CDIMPOSTO
            AND ITEMPROIMPOS.NRORG    = IMPOSTO.NRORG
        WHERE
         ITEMPROIMPOS.CDFILIAL    = :CDFILIAL
        AND ITEMPROIMPOS.NRLANCTONF  = :NRLANCTONF
        AND IMPOSTO.CDIMPOSTONFE     = :CDIMPOSTONFE
        AND IMPOSTO.NRORG            = :NRORG
SQL;
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "CDIMPOSTONFE" => $cdimpostonfe,
            "NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaItemNFE($cdfilial, $nrlanctonf, $cdpais, $sgestado)
    {
        $sql = <<<SQL
            SELECT
            NRORG,
            CDFILIAL,
            NRLANCTONF,
            SUBSTR(NRSEQITPROD, 2, 3) AS NRITEM,
            CDPRODUTO,
            NRSEQITPROD,
            CDPRODEMIS,
            SUBSTR(DSPRODEMIS, 1, 120) AS DSPRODEMIS,
            CDBARPRODUTO,
            CDAGREGACAO,
            DSISENCAOANVISA,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(QTITEMPROD, 4), '99999999.9999')), 1, 1), '.', '0'
                                                                                             || LTRIM(TO_CHAR(ROUND(QTITEMPROD, 4), '99999999.9999'
                                                                                             )), LTRIM(TO_CHAR(ROUND(QTITEMPROD, 4), '99999999.9999'
                                                                                             ))) AS QTITEMPROD,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRUNITITEM, 10), '999999999999.9999999999')), 1, 1), '.', '0'
                                                                                                        || LTRIM(TO_CHAR(ROUND(VRUNITITEM
                                                                                                        , 10), '999999999999.9999999999')
                                                                                                        ), LTRIM(TO_CHAR(ROUND(VRUNITITEM
                                                                                                        , 10), '999999999999.9999999999')
                                                                                                        )) AS VRUNITITEM,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRFRETEITEM, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                 || LTRIM(TO_CHAR(ROUND(VRFRETEITEM, 2), '9999999999999.99'
                                                                                                 )), LTRIM(TO_CHAR(ROUND(VRFRETEITEM, 2),
                                                                                                 '9999999999999.99'))) AS VRFRETE,
            VRFRETEITEM,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRSEGURITEM, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                 || LTRIM(TO_CHAR(ROUND(VRSEGURITEM, 2), '9999999999999.99'
                                                                                                 )), LTRIM(TO_CHAR(ROUND(VRSEGURITEM, 2),
                                                                                                 '9999999999999.99'))) AS VRSEGURO,
            VRSEGURITEM,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRENCARGODESC, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                   || LTRIM(TO_CHAR(ROUND(VRENCARGODESC, 2
                                                                                                   ), '9999999999999.99')), LTRIM(TO_CHAR
                                                                                                   (ROUND(VRENCARGODESC, 2), '9999999999999.99'
                                                                                                   ))) AS VRENCARGODESCONTO,
            VRENCARGODESC,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRDESCITEM, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                || LTRIM(TO_CHAR(ROUND(VRDESCITEM, 2), '9999999999999.99'
                                                                                                )), LTRIM(TO_CHAR(ROUND(VRDESCITEM, 2), '9999999999999.99'
                                                                                                ))) AS VRDESCONTO,
            VRDESCITEM,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRTOTAITEM, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                || LTRIM(TO_CHAR(ROUND(VRTOTAITEM, 2), '9999999999999.99'
                                                                                                )), LTRIM(TO_CHAR(ROUND(VRTOTAITEM, 2), '9999999999999.99'
                                                                                                ))) AS VRTOTAITEM,
            VRTOTAITEM     AS VRTOTAITEMFLOAT,
            CDCLASFISC     AS NCM,
            CDFISOPEITEM   AS CFOP,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRMAXVENDA, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                || LTRIM(TO_CHAR(ROUND(VRMAXVENDA, 2), '9999999999999.99'
                                                                                                )), LTRIM(TO_CHAR(ROUND(VRMAXVENDA, 2), '9999999999999.99'
                                                                                                ))) AS VRMAXVENDA,
            SGUNIDADE,
            NRLOTEESTQ,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(QTPRODLOTE, 3), '99999999.999')), 1, 1), '.', '0'
                                                                                            || LTRIM(TO_CHAR(ROUND(QTPRODLOTE, 3), '99999999.999'
                                                                                            )), LTRIM(TO_CHAR(ROUND(QTPRODLOTE, 3), '99999999.999'
                                                                                            ))) AS QTPRODLOTE,
            DTFABRPROD,
            DTVALILOTE,
            CDSITUTRIBPR,
            SUBSTR(CDSITUTRIBPR, 1, 1) AS ORIGEM,
            SUBSTR(CDSITUTRIBPR, 2, 2) AS CST,
            IDSEGMENTOPROD,
            NRLOTEESTQ     AS PRODUTO,
            CDARVPROD,
            CDFISCOPERSN,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRDESPADUANEIRA, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                     || LTRIM(TO_CHAR(ROUND(VRDESPADUANEIRA
                                                                                                     , 2), '9999999999999.99')), LTRIM(TO_CHAR
                                                                                                     (ROUND(VRDESPADUANEIRA, 2), '9999999999999.99'
                                                                                                     ))) AS DESPESASADUANEIRAS,
            VRDESPADUANEIRA,
            DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VROUTRASDESPITEM, 2), '9999999999999.99')), 1, 1), '.', '0'
                                                                                                      || LTRIM(TO_CHAR(ROUND(VROUTRASDESPITEM
                                                                                                      , 2), '9999999999999.99')), LTRIM(TO_CHAR
                                                                                                      (ROUND(VROUTRASDESPITEM, 2), '9999999999999.99'
                                                                                                      ))) AS OUTRASDESPESAS,
            VROUTRASDESPITEM,
            NRPEDPROD,
            NRSEQPEDPROD,
            VRTOTATRIB,
            CDCEST,
            DSINFADICPROD,
            NRREGISTROANVISA,
            SGUNIDADETRIB
        FROM
            (
                SELECT
                    IT.NRORG,
                    IT.CDFILIAL,
                    IT.NRLANCTONF,
                    SUBSTR(IT.NRSEQITPROD, 2, 3) AS NRITEM,
                    IT.CDPRODUTO,
                    IT.NRSEQITPROD,
                    IT.CDPRODEMIS,
                    IT.DSPRODEMIS,
                    IT.CDBARPRODUTO,
                    IT.QTITEMPROD,
                    IT.VRUNITITEM,
                    IT.VRDESCITEM,
                    IT.VRFRETEITEM,
                    IT.VRTOTAITEM,
                    IT.CDCLASFISC,
                    IT.CDFISOPEITEM,
                    VM.VRMAXVENDA,
                    IT.SGUNIDADE,
                    IT.NRLOTEESTQ,
                    IT.QTITEMPROD   AS QTPRODLOTE,
                    LT.CDAGREGACAO,
                    TO_CHAR(DTFABRPROD, 'YYYY-MM-DD') AS DTFABRPROD,
                    IT.VRSEGURITEM,
                    TO_CHAR(DTVALILOTE, 'YYYY-MM-DD') AS DTVALILOTE,
                    IT.VRENCARGODESC,
                    IT.CDSITUTRIBPR,
                    IT.IDSEGMENTOPROD,
                    IT.NRLOTEESTQ   AS PRODUTO,
                    IT.CDARVPROD,
                    SUBSTR(IT.CDFISCOPERSN, 2, 3) AS CDFISCOPERSN,
                    IT.VRDESPADUANEIRA,
                    IT.VROUTRASDESPITEM,
                    IT.NRPEDPROD,
                    IT.NRSEQPEDPROD,
                    IT.VRTOTATRIB,
                    IT.CDCEST,
                    IT.DSINFADICPROD,
                    IT.NRREGISTROANVISA,
                    IT.DSISENCAOANVISA,
                    IT.SGUNIDADETRIB
                FROM
                    LOTE LT,
                    (
                        SELECT
                            NRORG,
                            CDPAIS,
                            SGESTADO,
                            CDPRODUTO,
                            VRMAXVENDA,
                            VRPEMAXVENDA
                        FROM
                            VRMAXVENPROD
                        WHERE
                            CDPAIS = :CDPAISCLIE
                            AND SGESTADO = :SGESTACLIE
                    ) VM,
                    (
                        SELECT
                            I.NRORG,
                            I.CDFILIAL,
                            I.NRLANCTONF,
                            SUBSTR(I.NRSEQITPROD, 2, 3) AS NRITEM,
                            I.CDPRODUTO,
                            I.NRSEQITPROD,
                            I.CDPRODEMIS,
                            I.DSPRODEMIS,
                            PR.CDBARPRODUTO,
                            I.QTITEMPROD,
                            I.VRUNITITEM,
                            I.VRDESCITEM,
                            I.VRFRETEITEM,
                            I.VRTOTAITEM,
                            PR.CDCLASFISC,
                            I.CDFISOPEITEM,
                            PR.SGUNIDADE,
                            I.VRSEGURITEM,
                            I.NRLOTEESTQ,
                            I.QTITEMPROD   AS QTPRODLOTE,
                            I.VRENCARGODESC,
                            I.CDSITUTRIBPR,
                            PR.IDSEGMENTOPROD,
                            I.NRLOTEESTQ   AS PRODUTO,
                            PR.CDARVPROD,
                            I.CDFILIMOVI,
                            I.NRSUBLOTE,
                            NVL(I.CDPRODMOVI, PR.CDPRODESTO) AS CDPRODMOVI,
                            I.CDFISCOPERSN,
                            I.VRDESPADUANEIRA,
                            I.VROUTRASDESPITEM,
                            I.NRPEDPROD,
                            I.NRSEQPEDPROD,
                            I.VRTOTATRIB,
                            PR.CDCEST,
                            I.DSINFADICPROD,
                            INF.NRREGISTROANVISA,
                            INF.DSISENCAOANVISA,
                            PR.SGUNIDADETRIB
                        FROM
                            ITEMPRODUTO   I, PRODUTO       PR
                            LEFT JOIN INFADICPROD   INF ON ( PR.CDPRODUTO = INF.CDPRODUTO )
                        WHERE
                            I.CDFILIAL = :CDFILIAL
                            AND I.NRLANCTONF = :NRLANCTONF
                            AND I.CDPRODUTO = PR.CDPRODUTO
                            AND I.NRORG = PR.NRORG
                    ) IT
                WHERE
                    IT.CDPRODUTO = VM.CDPRODUTO (+)
                    AND IT.NRORG = VM.NRORG (+)
                    AND IT.CDFILIMOVI = LT.CDFILIAL (+)
                    AND IT.NRLOTEESTQ = LT.NRLOTEESTQ (+)
                    AND IT.NRSUBLOTE = LT.NRSUBLOTE (+)
                    AND IT.CDPRODMOVI = LT.CDPRODUTO (+)
                    AND IT.NRORG = LT.NRORG (+)
            )
        ORDER BY
            NRSEQITPROD
SQL;

        $params = array(
            "CDPAISCLIE" => $cdpais,
            "SGESTACLIE" => $sgestado,
            "CDFILIAL"   => $cdfilial,
            "NRLANCTONF" => $nrlanctonf
        );

        try{
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function consultaDadosImpostosNFE($cdfilial, $nrlanctonf, $nrseqitprod)
    {
        $sql = <<<SQL
        SELECT IP.CDIMPOSTONFE AS CDIMPOSTONFE,
              IT.CDFISCALIT,
              IT.CDIMPOSTO,
              IT.VRPERREDBCIT,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99'))) AS VALORIMPOSTO,
              IT.VRIMPOSTOIT                                                                                                                                                    AS VRIMPOSTOIT,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.9999')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.9999'))) AS VALORIMPOSTOALIQ,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99'))) AS BASECALCULO,
              IT.VRBASECALCIT,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRPERREDBCIT, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRPERREDBCIT, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRPERREDBCIT, 2), '999.99'))) AS PERCENTUALRED,
              (IT.VRALIQITEM - NVL(IT.VRADICALIQFECP, 0))                                                                 AS VALORIMPOSTOALIQ,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRALIQITEM, 2), '999.99'))) AS ALIQUOTA,
              SUBSTR(IT.CDSITUTRIBIT, 1, 1)                                                                                                                                               AS ORIGEM,
              IT.CDSITUTRIBITNFE                                                                                                                                                          AS CST,
              IP.CDIMPOSTRIB,
              IT.IDMODBCITNFE,
              IT.IDMODBCSTITNFE,
              IT.CDSITUTRIBIT,
              IP.CDTRIBISSQN,
              NVL(IT.IDIMPDESONERAIT, 'N') AS IDIMPDESONERAIT,
              IT.IDMOTDESONERAIT,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBCICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRBCICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBCICMSSTRETIDO, 2), '9999999999999.99'))) AS BASECALCULORETIDO,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRICMSSTRETIDO, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRICMSSTRETIDO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRICMSSTRETIDO, 2), '9999999999999.99'))) AS VALORIMPOSTORETIDO,
              SUBSTR(I.CDFISCOPERSN, 1, 1)                                                                                                        AS ORIGEMSN,
              VRIMPOSTOOPERAIT,
              VRPERDIFEREIT,
              VRIMPOSTODIFERIT,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOOPERAIT, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOOPERAIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOOPERAIT, 2), '9999999999999.99'))) AS VALORIMPOSTOOPERACAO,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRPERDIFEREIT, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRPERDIFEREIT, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRPERDIFEREIT, 2), '999.99'))) AS VALORPERCENTDIFERE,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTODIFERIT, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTODIFERIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTODIFERIT, 2), '9999999999999.99'))) AS VALORIMPOSTODIFERE,
              IT.CDENQLEGALIPI,
              IT.CDCEST,
              IT.VRBASECALCDEST,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBASECALCDEST, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRBASECALCDEST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBASECALCDEST, 2), '9999999999999.99'))) AS VALORBASECALCDESTINO,
              IT.VRALIQINTEDEST,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRALIQINTEDEST, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRALIQINTEDEST, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRALIQINTEDEST, 2), '999.99'))) AS VALORALIQINTEDESTINO,
              IT.VRPERCPARTILHA,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRPERCPARTILHA, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRPERCPARTILHA, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRPERCPARTILHA, 2), '999.99'))) AS VALORPERCENTUALPARTILHA,
              IT.VRIMPOPARTDEST,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOPARTDEST, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOPARTDEST, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOPARTDEST, 2), '9999999999999.99'))) AS VALORIMPOPARTDESTINO,
              IT.VRIMPOPARTREME,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOPARTREME, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOPARTREME, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOPARTREME, 2), '9999999999999.99'))) AS VALORIMPOPARTREMETENTE,
              IT.VRALIQFCP,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRALIQFCP, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRALIQFCP, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRALIQFCP, 2), '999.99'))) AS VALORALIQUOTAFCP,
              IT.VRIMPOFCP,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOFCP, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRIMPOFCP, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOFCP, 2), '9999999999999.99'))) AS VALORIMPOSTOFCP,
              IT.VRALIQINTEREST,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRALIQINTEREST, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRALIQINTEREST, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRALIQINTEREST, 2), '999.99'))) AS VALORALIQINTERESTADUAL,
              IT.VRADICALIQFECP,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRADICALIQFECP, 2), '999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRADICALIQFECP, 2), '999.99')), LTRIM(TO_CHAR(ROUND(IT.VRADICALIQFECP, 2), '999.99'))) AS VALORADICIONALALIQFECP,
              IT.VRADICFECP,
              DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRADICFECP, 2), '9999999999999.99')), 1, 1), '.', '0'
              ||LTRIM(TO_CHAR(ROUND(IT.VRADICFECP, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRADICFECP, 2), '9999999999999.99'))) AS VALORADICIONALFECP
            FROM ITEMPROIMPOS IT,
              IMPOSTO IP,
              ITEMPRODUTO I
            WHERE IT.CDIMPOSTO  = IP.CDIMPOSTO
            AND IT.CDFILIAL     = :CDFILIAL
            AND IT.NRLANCTONF   = :NRLANCTONF
            AND IT.NRSEQITPROD  = :NRSEQITPROD
            AND IT.NRITPROIMPOS = '1'
            AND IT.CDFILIAL     = I.CDFILIAL
            AND IT.NRLANCTONF   = I.NRLANCTONF
            AND IT.NRSEQITPROD  = I.NRSEQITPROD 
SQL;
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRSEQITPROD" => $nrseqitprod
        );

        try{
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function consultaDesoneraItem($cdfilial, $nrlanctonf, $nrseqitprod)
    {
        $sql = 
        "SELECT CDFILIAL, 
               NRLANCTONF, 
               SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SUM(VRIMPOSTOIT), 2), '9999999999999.99'))) AS VALORDESONERA,
               DECODE(substr(ltrim(TO_CHAR(round(SUM(vrimpostodeson), 2), '9999999999999.99')), 1, 1), '.', '0' || ltrim(TO_CHAR(round(SUM(vrimpostodeson), 2), '9999999999999.99')), ltrim(TO_CHAR(round(SUM(vrimpostodeson), 2),'9999999999999.99'))) AS vrtotaimpdeson  
          FROM ITEMPROIMPOS
         WHERE CDFILIAL = :CDFILIAL
           AND NRLANCTONF = :NRLANCTONF
           AND ((NRSEQITPROD = :NRSEQITPROD) OR (:NRSEQITPROD = 'T'))
           AND NRITPROIMPOS = '1'
           AND IDIMPDESONERAIT = 'S'
         GROUP BY CDFILIAL, NRLANCTONF";
         
        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRSEQITPROD" => $nrseqitprod
        );

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        
        try{
            return $std->fetchAll();  
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function consultaEncargosNotaFiscal($nrlanctonf, $cdfilial)
    {
        $sql = <<<SQL
        SELECT EN.CDENCARGONFE AS CDENCARGO,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SUM(IE.VRITEMENCA), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(SUM(IE.VRITEMENCA), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SUM(IE.VRITEMENCA), 2), '9999999999999.99'))) AS VALORENCARGO,
               SUM(IE.VRITEMENCA) AS VALORENCARGOFLOAT
          FROM ITEMENCARGO IE, ENCARGO EN
         WHERE IE.CDENCARGO = EN.CDENCARGO(+)
           AND IE.NRORG     = EN.NRORG(+)
           AND IE.CDFILIAL = :CDFILIAL
           AND IE.NRLANCTONF = :NRLANCTONF
           AND EN.CDENCARGONFE IS NOT NULL
        GROUP BY EN.CDENCARGONFE
SQL;

        $params = array(
            "NRLANCTONF" => $nrlanctonf,
            "CDFILIAL" => $cdfilial
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function getSomaDescontoItem($nrlanctonf, $cdfilial)
    {
        $sql = <<<SQL
         SELECT SUM(VRDESCITEM) AS VRDESCITEMTOT
                  FROM ITEMPRODUTO
                 WHERE CDFILIAL = :CDFILIAL
                   AND NRLANCTONF = :NRLANCTONF
SQL;

        $params = array(
            "NRLANCTONF" => $nrlanctonf,
            "CDFILIAL" => $cdfilial
        );

        try {
            return $this->entityManager->getConnection()->fetchColumn($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function somaTotalItensNF($nrlanctonf, $cdfilial)
    {
        $sql = <<<SQL
        SELECT DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SUM(VRTOTAITEM), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(SUM(VRTOTAITEM), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SUM(VRTOTAITEM), 2), '9999999999999.99'))) AS VRTOTALITENS,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SUM(VRDESCITEM), 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(SUM(VRDESCITEM), 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SUM(VRDESCITEM), 2), '9999999999999.99'))) AS VRTOTDESCITEM,
               SUM(VRTOTAITEM) AS VRTOTALITENSFLOAT,
               SUM(VRDESCITEM) AS VRTOTDESCITEMFLOAT
          FROM ITEMPRODUTO
         WHERE CDFILIAL = :CDFILIAL
           AND NRLANCTONF = :NRLANCTONF
SQL;
        $params = array(
            "NRLANCTONF" => $nrlanctonf,
            "CDFILIAL" => $cdfilial
        );

        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function consultaContarecerNFE($cdfilial, $nrlanctonf)
    {
        $sql = <<<SQL
                SELECT 
                C.NRSEQVENREC AS NRSEQVEN,
                C.DTORIGVENREC AS DTORIGVEN,      
                DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C.VRORIGREC, 2), '9999999999999.99')), 1, 1), '.', '0'||
                LTRIM(TO_CHAR(ROUND(C.VRORIGREC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C.VRORIGREC, 2),'9999999999999.99'))) AS VRORIG,
                SC.VRORIGREC AS VRLIQFATURA,      
                DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SC.VRORIGREC, 2), '9999999999999.99')), 1, 1), '.', '0'||
                LTRIM(TO_CHAR(ROUND(SC.VRORIGREC, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SC.VRORIGREC, 2), '9999999999999.99'))) AS STVRLIQFATURA
          FROM CONTARECEBER C,
               (SELECT CDFILIAL,
                       NRLANCTONF,
                       SUM(ROUND(VRORIGREC, 2)) AS VRORIGREC
                  FROM CONTARECEBER
                 WHERE CDFILIAL   = :P_CDFILIAL
                   AND NRLANCTONF = :P_NRLANCTONF
                 GROUP BY CDFILIAL,
                       NRLANCTONF) SC
         WHERE C.CDFILIAL   = SC.CDFILIAL
           AND C.NRLANCTONF = SC.NRLANCTONF
           AND C.CDFILIAL   = :P_CDFILIAL
           AND C.NRLANCTONF = :P_NRLANCTONF
         UNION ALL
        SELECT C.NRSEQVENPAG AS NRSEQVEN,
               C.DTORIGVENPAG AS DTORIGVEN,
                 DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(C.VRORIGPAG, 2), '9999999999999.99')), 1, 1), '.', '0'||
                 LTRIM(TO_CHAR(ROUND(C.VRORIGPAG, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(C.VRORIGPAG, 2),'9999999999999.99'))) AS VRORIG, SC.VRORIGPAG AS VRLIQFATURA,
                 DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(SC.VRORIGPAG, 2), '9999999999999.99')), 1, 1), '.', '0'||
                 LTRIM(TO_CHAR(ROUND(SC.VRORIGPAG, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(SC.VRORIGPAG, 2), '9999999999999.99'))) AS STVRLIQFATURA
          FROM CONTAPAGAR C,
               (SELECT CDFILIAL,
                       NRLANCTONF,
                       SUM(ROUND(VRORIGPAG, 2)) AS VRORIGPAG
                  FROM CONTAPAGAR
                 WHERE CDFILIAL   = :P_CDFILIAL
                   AND NRLANCTONF = :P_NRLANCTONF
                 GROUP BY CDFILIAL,
                       NRLANCTONF) SC
         WHERE C.CDFILIAL   = SC.CDFILIAL
           AND C.NRLANCTONF = SC.NRLANCTONF
           AND C.CDFILIAL   = :P_CDFILIAL
           AND C.NRLANCTONF = :P_NRLANCTONF
        ORDER BY DTORIGVEN, NRSEQVEN
SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf
        );

        try{
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function consultaListaNFE($cdfilial, $nrlanctonf)
    {
        $sql = <<<SQL
        SELECT RPAD(NMGRUPO,16, ' ')||' R$: '||REPLACE(TO_CHAR(ROUND(VRLISTA,2),'99999999.00'),'.', ',') AS DSLISTA
        FROM(
        SELECT SUBSTR(P.CDARVPROD, 1, 1) AS GRUPO, 'Lista Positiva' AS NMGRUPO, SUM(VRTOTAITEM)AS VRLISTA
        FROM ITEMPRODUTO I, PRODUTO P
        WHERE I.CDFILIAL   = :FILIAL   AND
              I.NRLANCTONF = :LANCAMENTO AND
              I.CDPRODUTO  = P.CDPRODUTO AND
              I.NRORG      = P.NRORG     AND
              P.IDSEGMENTOPROD = 'MEDI' AND
              (SUBSTR(P.CDARVPROD, 1, 5) = '50101' OR SUBSTR(P.CDARVPROD, 1, 5) = '50103' OR SUBSTR(P.CDARVPROD, 1, 5) = '50301' OR SUBSTR(P.CDARVPROD, 1, 5) = '50303')
        GROUP BY SUBSTR(P.CDARVPROD, 1, 1)
        UNION ALL
        SELECT SUBSTR(P.CDARVPROD, 1, 1) AS GRUPO, 'Lista Negativa' AS NMGRUPO, SUM(VRTOTAITEM)AS VRLISTA
        FROM ITEMPRODUTO I, PRODUTO P
        WHERE I.CDFILIAL     = :FILIAL   AND
              I.NRLANCTONF   = :LANCAMENTO AND
              I.CDPRODUTO = P.CDPRODUTO AND
              I.NRORG     = P.NRORG     AND
              P.IDSEGMENTOPROD = 'MEDI' AND
              (SUBSTR(P.CDARVPROD, 1, 5) = '50102' OR SUBSTR(P.CDARVPROD, 1, 5) = '50104' OR SUBSTR(P.CDARVPROD, 1, 5) = '50302' OR SUBSTR(P.CDARVPROD, 1, 5) = '50304')
        GROUP BY SUBSTR(P.CDARVPROD, 1, 1))
SQL;

        $params = array(
            "FILIAL" => $cdfilial,
            "LANCAMENTO" => $nrlanctonf,
        );

        try{
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function consultaFormaPagamentoSaida($cdfilial, $nrlanctonf, $idorigdestnf, \DateTime $dtentrsaid)
    {
        $dtentrsaid = $dtentrsaid->format($this->entityManager->getConnection()->getDatabasePlatform()->getDateFormatString());
        $sql = <<<SQl
            SELECT DECODE(DTATUAVENREC, NULL, CONSULTA_FORMPGTO(:CDFILIAL, :NRLANCTONF, :IDORIGDESTNF),
                   DECODE(TO_DATE(MAX(DTATUAVENREC), 'DD/MM/YYYY HH24:MI:SS') - TO_DATE('{$dtentrsaid}', 'DD/MM/YYYY HH24:MI:SS'),0,0,1)) AS IDFORMPGTSAP
              FROM CONTARECEBER
             WHERE CDFILIAL = :CDFILIAL
               AND NRLANCTONF = :NRLANCTONF
            GROUP BY DTATUAVENREC
SQl;

        $params = array(
            "CDFILIAL"     => $cdfilial,
            "NRLANCTONF"   => $nrlanctonf,
            "IDORIGDESTNF" => $idorigdestnf,
            //            "DTENTRSAID"   => $dtentrsaid
        );

        try{
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function consultaFormaPagamentoEntrada($cdfilial, $nrlanctonf, $idorigdestnf, $dtentrsaid)
    {
        $dtentrsaid = $dtentrsaid->format($this->entityManager->getConnection()->getDatabasePlatform()->getDateFormatString());
        $sql = <<<SQl
            SELECT DECODE(DTATUAVENPAG, NULL, CONSULTA_FORMPGTO(:P_CDFILIAL, :P_NRLANCTONF, :P_IDORIGDESTNF),
                   DECODE(TO_DATE(MAX(DTATUAVENPAG), 'DD/MM/YYYY HH24:MI:SS') - TO_DATE('{$dtentrsaid}', 'DD/MM/YYYY HH24:MI:SS'),0,0,1)) AS IDFORMPGTSAP
              FROM CONTAPAGAR
             WHERE CDFILIAL = :P_CDFILIAL
               AND NRLANCTONF = :P_NRLANCTONF
            GROUP BY DTATUAVENPAG
SQl;

        $params = array(
            "P_CDFILIAL"     => $cdfilial,
            "P_NRLANCTONF"   => $nrlanctonf,
            "P_IDORIGDESTNF" => $idorigdestnf,
            "P_DTENTRSAID"   => $dtentrsaid
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function getDadosEmailNfe($cdfiliemit, $nrlanctonf){

        $sql = <<<SQL
                      SELECT N.NRORG, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISCALELE, N.NRACESSONFE, D.DSARQXMLNFE AS DSXMLNFE, A.DSARQXMLNFE AS DSXMLRECIBONFE,
                   F.CDFILIAL AS CDFILIALORIG, E.NMEMPRESA AS NMRAZSOCORIG, NVL(EF.DSLOGINSMTP, NVL(EF.DSEMAILEMXMLNFE, EF.DSEMAILFILI)) AS DSEMAILORIG,
                   NVL(EF.DSLOGINSMTP, NVL(EF.DSEMAILEMXMLNFE, EF.DSEMAILFILI)) AS DSLOGINSMTPORIG, EF.CDSENHEMAILF AS CDSENHEMAILORIG, EF.DSSMTPEMAILF AS DSSMTPEMAILORIG,
                   N.IDORIGDESTNF, ED.CDDESTNFE, ED.NMRAZSOCDEST, LOWER(ED.DSEMAILDEST) AS DSEMAILDEST, ED.COMPACTAR, E.DSMENSEMAILNFE,
                   N.IDTPIJURTRAN, N.NRINSJURTRAN, NVL(LOWER(TP.DSEMAILTRANSPNFE), LOWER(TP.DSEMAILTRAN)) AS DSEMAILTRANSPNFE, NVL(TP.IDCOMPARQXMLTRA, 'S') IDCOMPARQXMLTRA,
                   N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, NVL(N.CDSERIE, N.CDSERIEENTR) AS CDSERIE, EF.IDUTSSLEMAIL, EF.IDUTTLSEMAIL, C.DSARQXMLNFE AS DSXMLCANCNFE,
                   E.DSMENSEMAILCANC
              FROM NOTAFISCAL N, ARQXMLNFE D, ARQXMLNFE A, ARQXMLNFE C, ENDEFILI EF, FILIAL F, EMPRESA E,
                   TRANSPORT TP,
                   (SELECT C.NRORG AS NRORG, C.CDCLIENTE AS CDDESTNFE, C.NMRAZSOCCLIE AS NMRAZSOCDEST, EC.DSEMAILCLIENFE AS DSEMAILDEST, C.IDCOMPARQXMLCLI AS COMPACTAR, 'C' AS IDENTIFICADOR
                      FROM CLIENTE C, ENDECLIE EC
                     WHERE C.CDCLIENTE = EC.CDCLIENTE(+)
                       AND 'P' = EC.IDTPENDECLIE(+)
                       AND C.NRORG    = EC.NRORG(+)
                     UNION
                    SELECT F.NRORG AS NRORG, F.CDFORNECED AS CDDESTNFE, F.NMRAZSOCFORN AS NMRAZSOCDEST, EF.DSEMAILFORNNFE AS DSEMAILDEST, F.IDCOMPARQXMLFOR AS COMPACTAR, 'F' AS IDENTIFICADOR
                      FROM FORNECEDOR F, ENDEFORN EF
                     WHERE F.CDFORNECED = EF.CDFORNECED(+)
                       AND 'P' = EF.IDTPENDEFORN(+)
                       AND F.NRORG      = EF.NRORG(+)
                     UNION
                    SELECT FL.NRORG AS NRORG, FL.CDFILIAL AS CDDESTNFE, FL.NMFILIAL AS NMRAZSOCDEST, EFL.DSEMAILEMXMLNFE AS DSEMAILDEST, FL.IDCOMPARQXMLFIL AS COMPACTAR, 'L' AS IDENTIFICADOR
                      FROM FILIAL FL, ENDEFILI EFL
                     WHERE FL.CDFILIAL = EFL.CDFILIAL(+)
                       AND 'P' = EFL.IDTPENDEFILI(+)
                       AND FL.NRORG     = EFL.NRORG(+)) ED
             WHERE N.CDFILIAL = :P_CDFILIAL
               AND N.NRLANCTONF = :P_NRLANCTONF
               AND N.CDEMPRESA = E.CDEMPRESA(+)
               AND N.NRORG     = E.NRORG(+)
               AND N.CDFILIAL = D.CDFILIAL(+)
               AND N.NRLANCTONF = D.NRLANCTONF(+)
               AND 'D' = D.IDTIPOARQXML(+)
               AND N.NRORG    = D.NRORG(+)
               AND N.CDFILIAL = A.CDFILIAL(+)
               AND N.NRLANCTONF = A.NRLANCTONF(+)
               AND 'A' = A.IDTIPOARQXML(+)
               AND N.NRORG    = A.NRORG(+)
               AND N.CDFILIAL = C.CDFILIAL(+)
               AND N.NRLANCTONF = C.NRLANCTONF(+)
               AND 'C' = C.IDTIPOARQXML(+)
               AND N.NRORG     = C.NRORG(+)
               AND N.IDTPIJURTRAN = TP.IDTPIJURTRAN(+)
               AND N.NRINSJURTRAN = TP.NRINSJURTRAN(+)
               AND N.NRORG        = TP.NRORG(+)
               AND DECODE(N.IDENTRSAIDOP, 'S', N.CDFILIEMIT, N.CDFILIRECE) = F.CDFILIAL
               AND N.NRORG        = F.NRORG(+)
               AND F.CDFILIAL = EF.CDFILIAL(+)
               AND 'P' = EF.IDTPENDEFILI(+)
               AND F.NRORG    = EF.NRORG(+)
               AND N.IDORIGDESTNF = ED.IDENTIFICADOR(+)
               AND N.NRORG        = ED.NRORG(+)
               AND DECODE(N.IDORIGDESTNF, 'C', N.CDCLIENTE,
                                          'F', N.CDFORNECED,
                                           DECODE(N.IDENTRSAIDOP, 'S', N.CDFILIRECE, N.CDFILIEMIT)) = ED.CDDESTNFE(+)

SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfiliemit,
            "P_NRLANCTONF" => $nrlanctonf
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaDevolucaoNF($cdfilial, $nrlanctonf)
    {
        $sql = <<<SQL
   SELECT IT.NRLANCTONF,NF.NRACESSONFE, IDTIPOEMISNFE, CDMODDOCFISC, NF.DTEMISSAO, NF.NRNOTAFISC,
          DECODE(IDTIPOEMISNFE, '3', NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN), NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE)) AS CDSERIE
     FROM ITEMNOTAFISC IT
     JOIN NOTAFISCAL NF
       ON IT.CDFILIALIT = NF.CDFILIAL
      AND IT.NRLANCTONFIT = NF.NRLANCTONF
LEFT JOIN SERIENF S
       ON NF.CDEMPRESA = S.CDEMPRESA
      AND NF.CDINSCESTA = S.CDINSCESTA
      AND NF.CDINSCMUNI = S.CDINSCMUNI
      AND NF.CDSERIE = S.CDSERIE
LEFT JOIN SERIEENTR SE
       ON NF.CDSERIEENTR = SE.CDSERIEENTR
    WHERE IT.CDFILIAL = :CDFILIAL
      AND IT.NRLANCTONF = :NRLANCTONF
SQL;
        $params = array(
                    "CDFILIAL"   => $cdfilial,
                    "NRLANCTONF" => $nrlanctonf
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaNotaFiscalProdRural($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
        SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRINSJURIEST, NF.CDSERIE, NF.NRACESSONFE,
               NF.NRNOTAFISC, NF.CDINSCESTA, NF.CDPAIS, NF.SGESTADO,
               NF.DTEMISSAO AS DTEMISSAO, NF.CDMODDOCFISC, ES.CDESTADOIBGE, NF.IDTPINSCJUR
          FROM NFPRODRURAL NF, ESTADO ES
         WHERE ES.CDPAIS = NF.CDPAIS
           AND ES.SGESTADO = NF.SGESTADO
           AND NF.CDFILIAL = :CDFILIAL
           AND NF.NRLANCTONF = :NRLANCTONF
           AND NF.NRORG     = :NRORG
         ORDER BY NF.NRINSJURIEST, NF.CDSERIE, NF.NRNOTAFISC
SQL;

        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaCupomFiscal($cdfilial, $nrlanctonf, $nrorg)
   {
       $sql = <<<SQL
       SELECT D.CDFILIAL, D.NRLANCTONF, D.CDPAIS, D.SGESTADO,
              D.CDMUNICIPIO, D.NRINSJUDESNF, D.NMRAZSODESNF, D.DSENDEDESTNF,
              D.NMBAIRDESTNF, D.IDTPIJUDESNF, D.NRMD5ARQTXTNF, D.NRCOOCUPOMNF,
              D.NRSERIEIMPNF, D.DSMODELOECFNF, D.DSMARCAECFNF, D.NRECFCUPOMNF, D.NRINSESTDESNF,  D.NRACESSONFCENF,
              P.CDPAISBACEN, E.CDESTADOIBGE, M.CDMUNICIBGE, M.NMMUNICIPIO, P.NMPAIS
         FROM DADOSNF D, PAIS P, ESTADO E, MUNICIPIO M
        WHERE D.CDPAIS = P.CDPAIS
          AND D.CDPAIS = E.CDPAIS
          AND D.SGESTADO = E.SGESTADO
          AND D.CDPAIS = M.CDPAIS
          AND D.SGESTADO = M.SGESTADO
          AND D.CDMUNICIPIO = M.CDMUNICIPIO
          AND D.CDFILIAL = :CDFILIAL
          AND D.NRLANCTONF = :NRLANCTONF
          AND D.NRORG      = :NRORG
SQL;

       $params = array(
           'CDFILIAL' => $cdfilial,
           'NRLANCTONF' => $nrlanctonf,
           'NRORG' => $nrorg
       );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
   }

   public function consultaInscricaoSuframaNFE($cliente)
    {
        $sql = <<<SQL
        SELECT NRINSCSUFRAMAFI AS NRSUFRAMA
          FROM FILIAL
         WHERE CDFILIAL     = :P_CLIENTE
        UNION ALL
        SELECT NRINSCSUFRAMAFO AS NRSUFRAMA
          FROM FORNECEDOR
         WHERE CDFORNECED   = :P_CLIENTE
        UNION ALL
        SELECT NRINSCSUFRAMACL AS NRSUFRAMA
          FROM CLIENTE
         WHERE CDCLIENTE    = :P_CLIENTE
SQL;

        return $this->entityManager->getConnection()->fetchAssoc($sql, array("P_CLIENTE" => $cliente));
    }

    public function consultaMaxValorSuframa($cdpais, $sgestado)
    {
        $sql = <<<SQL
        SELECT DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(VRMAXVENDA, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(VRMAXVENDA, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(VRMAXVENDA, 2), '9999999999999.99'))) AS VRMAXVENDA
          FROM VRMAXVENPROD
         WHERE CDPAIS = :CDPAISCLIE
           AND SGESTADO = :SGESTACLIE
SQL;
        $params = array(
            "CDPAISCLIE" => $cdpais,
            "SGESTACLIE" => $sgestado
        );

        return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
    }

    public function consultaClassificacaoServico($cdarvprod)
    {
        $sql = <<<SQL
        SELECT CDCLASSPROD
        FROM PRODUTO P,
            (SELECT MAX(CDARVPROD)  CDARVPROD
             FROM PRODUTO
             WHERE (INSTR(:CDARVPROD ,NVL(RTRIM(CDARVPROD), :CDARVPROD)) = 1)
               AND CDCLASSPROD IS NOT NULL  ) A
        WHERE
          A.CDARVPROD = P.CDARVPROD
SQL;
        $params = array(
            "CDARVPROD" => $cdarvprod
        );

        return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
    }

    public function consultaBloqueiaNotaFiscal($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
    SELECT CDFILIAL
    FROM NOTAFISCAL
    WHERE CDFILIAL   = :CDFILIAL   AND
          NRLANCTONF = :NRLANCTONF AND
          NRORG = :NRORG
    FOR UPDATE NOWAIT
SQL;
        try{

            $params = array(
                "CDFILIAL" => $cdfilial,
                "NRLANCTONF" => $nrlanctonf,
                "NRORG" => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }

    public function getIdErroAviso($cdfilial){
        $sql = <<<SQL
                  SELECT IDERROAVISOFIL
                    FROM ERROAVISONFFIL
                   WHERE CDERROAVISOFIL = 'ER03'
                     AND CDFILIAL = :P_CDFILIORIG
SQL;

        $params = array(
            "P_CDFILIORIG" => $cdfilial
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function getValorTotalImposto($cdfilial, $nrlanctonf, $iderroaviso, $nrdectotanf){
        $sql = <<<SQL
                  SELECT ROUND(NVL(SUM(T.VRIMPOSTOT),0),:P_NRDECTOTANF) AS V_VRIMPOSTOT
                    FROM TRABIMPOSNFTOT T, IMPOSTO I
                   WHERE T.CDFILIMPTOT  = :P_CDFILIAL    AND
                         T.NRLANCIMPTOT = :P_NRLANCTONF  AND
                         :P_IDERROAVISO  <> 'N'          AND
                         T.CDIMPOSTOT   = I.CDIMPOSTO   AND
                         I.IDTRATIMPO   = 'R'           AND
                         I.IDDESCRFONTE = 'R'
SQL;

        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_IDERROAVISO" => $iderroaviso,
            "P_NRDECTOTANF" => $nrdectotanf
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function getValorSubtracaoVencimentos($cdfilial, $nrlanctonf, $identrsaid, $cdtipooper){
        $sql = <<<SQL
                  SELECT NVL(SUM(VRBRUTITEM),0) AS VRSUBTRAIVENC
                    FROM ITEMPRODUTO IT, TPOPERCFOP T
                   WHERE IT.CDFILIAL   = :P_CDFILIAL
                     AND IT.NRLANCTONF = :P_NRLANCTONF
                     AND T.IDENTRSAIDOP = :P_IDENTRSAID
                     AND T.CDTIPOOPER   = :P_CDTIPOOPER
                     AND T.IDCOMPOEVENC = 'N'
                     AND T.CDFISCOPER   = IT.CDFISOPEITEM
SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_IDENTRSAID" => $identrsaid,
            "P_CDTIPOOPER" => $cdtipooper
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function getValorTotalVencimentos($cdfilial, $nrlanctonf, $vrimpostot, $vrsubtraivenc){
        $sql = <<<SQL
                  SELECT ABS(NVL(SUM(VRORIGREC),(NF.VRNOTAFISC - :P_VRIMPOSTOT - :P_VRSUBTRAIVENC)) - (NF.VRNOTAFISC - :P_VRIMPOSTOT - :P_VRSUBTRAIVENC)) AS VRDIFERENCA
                    FROM CONTARECEBER CR, NOTAFISCAL NF
                   WHERE CR.CDFILIAL   =  :P_CDFILIAL
                     AND CR.NRLANCTONF =  :P_NRLANCTONF
                     AND NF.CDFILIAL = CR.CDFILIAL
                     AND NF.NRLANCTONF = CR.NRLANCTONF
                GROUP BY NF.VRNOTAFISC
SQL;

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_VRIMPOSTOT" => $vrimpostot,
            "P_VRSUBTRAIVENC" => $vrsubtraivenc
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consisteFiscal($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
    SELECT CDIMPOSTO, NRSEQITPROD, NRSEQCONSISTE, DSCONSISTENCIA, CDARVPROD, NMPRODUTO,
       CDREGRAIT
  FROM TABLE(CONSISTE_FISCAL(:P_CDFILIAL, :P_NRLANCTONF))
SQL;

        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaFilialOrigem($cdfilial, $nrlanctonf, $nrorg)
    {
        $sql = <<<SQL
    SELECT DECODE(IDENTRSAIDOP, 'S', CDFILIEMIT, CDFILIRECE) AS CDFILIORIG
      FROM NOTAFISCAL
     WHERE CDFILIAL   = :CDFILIAL
       AND NRLANCTONF = :NRLANCTONF
       AND NRORG = :NRORG
SQL;

        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
    }

    public function consultaNotaDevolucao($cdfilial, $nrlanctonf, $nrorg){
        $sql = <<<SQL
        SELECT NF.NRACESSONFE, IDTIPOEMISNFE,
               DECODE(IDTIPOEMISNFE, '3', NVL(S.CDSERIENFESCAN, SE.CDSERIEENTSCAN), NVL(S.CDSERIENFE, SE.CDSERIEENTRNFE)) AS CDSERIE
          FROM ITEMNOTAFISC IT, NOTAFISCAL NF, SERIENF S, SERIEENTR SE
         WHERE IT.CDFILIAL = :P_CDFILIAL
           AND IT.NRLANCTONF = :P_NRLANCTONF
           AND IT.NRORG     = :P_NRORG
           AND IT.CDFILIALIT = NF.CDFILIAL
           AND IT.NRLANCTONFIT = NF.NRLANCTONF
           AND IT.NRORG       = NF.NRORG
           AND NF.CDEMPRESA = S.CDEMPRESA(+)
           AND NF.CDINSCESTA = S.CDINSCESTA(+)
           AND NF.CDINSCMUNI = S.CDINSCMUNI(+)
           AND NF.CDSERIE = S.CDSERIE(+)
           AND NF.CDSERIEENTR = SE.CDSERIEENTR(+)
SQL;

        $params = array(
            'P_CDFILIAL'      => $cdfilial,
            'P_NRLANCTONF'   => $nrlanctonf,
            'P_NRORG'      => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaFilialCentralizadora($cdfilial, $nrorg)
    {
        $sql = <<<SQL
        SELECT L.CDFILIFISC, F.CDSERIE, F.CDEMPRESA, F.CDINSCESTA,
               F.CDINSCMUNI, P.DTPROCESSA
          FROM FILIAL L
          JOIN FILIAL F
          ON L.CDFILIFISC = F.CDFILIAL
          JOIN PARAMFILIAL P
          ON P.CDFILIAL   = L.CDFILIFISC
         WHERE L.CDFILIAL   = :CDFILIAL
         AND L.NRORG = :NRORG
SQL;

        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAssoc($sql, $params);
    }

    public function consultaItemNotaFiscal($cdfilial, $nrlanctonf, $cdpais, $sgestado, $nrorg)
    {
        $sql = <<<SQL
        SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, CDCLASFISC AS NCM, NRORG,
               CDARVPROD, CDFISOPEITEM AS CFOP, CDSITUTRIBPR, IDSEGMENTOPROD,
               DTFABRPROD, CDBARPRODUTO, CDFISCOPERSN, CSOSN, NRLOTEESTQ, CDPRODUTO
          FROM (SELECT IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD, IT.CDCLASFISC, IT.NRORG,
                       IT.CDARVPROD, IT.CDFISOPEITEM, IT.CDSITUTRIBPR, IT.IDSEGMENTOPROD,
                       TO_CHAR(DTFABRPROD, 'YYYY-MM-DD') AS DTFABRPROD, IT.CDBARPRODUTO, IT.CDFISCOPERSN,
                       IT.CSOSN, IT.NRLOTEESTQ, IT.CDPRODUTO
                  FROM LOTE LT, (SELECT CDPRODUTO
                                   FROM VRMAXVENPROD
                                  WHERE CDPAIS = :CDPAISCLIE
                                    AND SGESTADO = :SGESTACLIE) VM,
                                (SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, PR.CDCLASFISC, I.NRORG,
                                        PR.CDARVPROD, CDFISOPEITEM, I.CDSITUTRIBPR, PR.IDSEGMENTOPROD,
                                        PR.CDBARPRODUTO, SUBSTR(I.CDFISCOPERSN, 2, 3) AS CDFISCOPERSN,
                                        I.CDPRODUTO, I.CDFILIMOVI, I.NRLOTEESTQ, I.NRSUBLOTE, I.CDPRODMOVI,
                                        I.CDFISCOPERSN AS CSOSN
                                   FROM ITEMPRODUTO I, PRODUTO PR
                                  WHERE I.CDFILIAL = :CDFILIAL
                                    AND I.NRLANCTONF = :NRLANCTONF
                                    AND I.NRORG     = :NRORG
                                    AND I.CDPRODUTO = PR.CDPRODUTO) IT
                 WHERE IT.CDPRODUTO = VM.CDPRODUTO(+)
                   AND IT.CDFILIMOVI = LT.CDFILIAL(+)
                   AND IT.NRORG       = LT.NRORG(+)
                   AND IT.NRLOTEESTQ = LT.NRLOTEESTQ(+)
                   AND IT.NRSUBLOTE  = LT.NRSUBLOTE(+)
                   AND IT.CDPRODMOVI = LT.CDPRODUTO(+))
         ORDER BY NRSEQITPROD

SQL;

        $params = array(
                    "CDFILIAL"   => $cdfilial,
                    "NRLANCTONF" => $nrlanctonf,
                    "CDPAISCLIE" => $cdpais,
                    "SGESTACLIE" => $sgestado,
                    "NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function verificaAdicoes($cdfilial, $nrlanctonf, $nrseqitprod, $nrorg)
    {
        $sql = <<<SQL
            SELECT
            COUNT(NRSEQADICDEC) AS QTDACICOES
          FROM ADICDECIMPNFE
         WHERE CDFILIAL = :CDFILIAL
           AND NRLANCTONF = :NRLANCTONF
           AND NRSEQITPROD = :NRSEQITPROD
           AND NRORG      = :NRORG
SQL;

        $params = array(
            "CDFILIAL" => $cdfilial,
            "NRLANCTONF" => $nrlanctonf,
            "NRSEQITPROD" => $nrseqitprod,
            "NRORG" => $nrorg
        );

        $return = $this->entityManager->getConnection()->fetchAll($sql, $params);
        return empty($return) ? 0 : $return[0]["QTDACICOES"];
    }
    
    public function getDecimpnfeInfo($params){
        $sql = <<<SQL
        SELECT DE.CDFILIAL, DE.NRLANCTONF, DE.NRSEQITPROD, DE.NRDOCIMPNFE,
       DE.DTREGIMPNFE, DE.DSLOCEMBIMP, DE.SGUFLOCEMBIMP, DE.DTDESEMBIMP,
       DE.CDEXPIMPNFE, DE.IDVIATRANSPORTE, DE.VRAFRMM, DE.IDFORMAIMPORTA,
       DE.NRINSJURADQUIRE, DE.CDPAISADQUIRE, DE.SGESTADOADQUIRE, DE.CDPAISLOCEMBIMP
  FROM DECIMPNFE DE
 WHERE DE.CDFILIAL = :P_CDFILIAL
   AND DE.NRLANCTONF = :P_NRLANCTONF
   AND ((DE.NRSEQITPROD = :P_NRSEQITPROD) OR (:P_NRSEQITPROD = 'T'))

SQL;

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }
    
    public function getAdicdecimpnfeInfo($params){
        $sql = <<<SQL
        SELECT AD.CDFILIAL, AD.NRLANCTONF, AD.NRSEQITPROD, AD.NRSEQADICDEC,
       AD.NRADICDECIMP, AD.CDFABRICADIC, AD.VRDESCADICDEC, AD.NRDRAWBACK
  FROM ADICDECIMPNFE AD
 WHERE AD.CDFILIAL = :P_CDFILIAL
   AND AD.NRLANCTONF = :P_NRLANCTONF
   AND ((AD.NRSEQITPROD = :P_NRSEQITPROD) OR (:P_NRSEQITPROD = 'T'))
 ORDER BY AD.NRSEQADICDEC

SQL;

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaImpostosItem($cdfilial, $nrlanctonf, $nrseqitprod, $nrorg){
        $sql = <<<SQL
        SELECT IT.CDFILIAL,
               IT.NRLANCTONF,
               IT.NRORG,
               IT.NRSEQITPROD,
               IT.CDIMPOSTO,
               IP.CDIMPOSTONFE,
               IP.CDIMPOSTRIB,
               IT.VRBASECALCIT,
               IT.VRIMPOSTOIT,
               IT.CDFISCALIT,
               IT.CDSITUTRIBIT,
               IT.CDSITUTRIBITNFE AS CST,
               IT.IDMODBCITNFE,
               IP.CDTRIBISSQN,
               IT.IDMODBCSTITNFE,
               IT.IDIMPDESONERAIT,
               IT.IDMOTDESONERAIT,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRBASECALCIT, 2), '9999999999999.99'))) AS BASECALCULO,
               DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), 1, 1), '.', '0'||LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(IT.VRIMPOSTOIT, 2), '9999999999999.99'))) AS VALORIMPOSTO
          FROM ITEMPROIMPOS IT, IMPOSTO IP
         WHERE IT.CDIMPOSTO = IP.CDIMPOSTO
           AND IT.NRORG     = IP.NRORG
           AND IT.CDFILIAL = :P_CDFILIAL
           AND IT.NRLANCTONF = :P_NRLANCTONF
           AND IT.NRSEQITPROD = :P_NRSEQITPROD
           AND IT.NRORG       = :P_NRORG
           AND IT.NRITPROIMPOS = '1'
SQL;
        $params = array(
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlanctonf,
            "P_NRSEQITPROD" => $nrseqitprod,
            "P_NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function retornaImpostosNFE($nrorg){
        $sql = <<<SQL
        SELECT I.CDIMPOSTONFE, IM.CDIMPOSTO
          FROM IMPOSTONFE I, IMPOSTO IM
         WHERE I.CDIMPOSTONFE = IM.CDIMPOSTONFE
           AND I.NRORG        = IM.NRORG
           AND I.NRORG        = :NRORG
SQL;
        $params = array(
            "NRORG" => $nrorg
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }

    public function consultaQuantidadeDuplicata($cdfilial, $nrlanctonf)
    {
        $sql = <<<SQL
        SELECT COUNT(*) AS QTDDUPLICATA
          FROM CONTARECEBER
         WHERE CDFILIAL = :CDFILIAL
           AND NRLANCTONF = :NRLANCTONF
SQL;
        $params = array(
            "CDFILIAL"   => $cdfilial,
            "NRLANCTONF" => $nrlanctonf
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }
    
    public function getParamGeral()
    {
        $sql = <<<SQL
        SELECT * FROM PARAMGERAL
SQL;

        return $this->entityManager->getConnection()->fetchAll($sql);
    }
    
    public function getDtEmissaoTransmite($nrlanctonf, $cdfilial) {
         $sql = <<<SQL
        SELECT CASE P.IDUTDTBCDTEMISS
          WHEN 'S'
          THEN NVL(N.DTEMISSAO, TRUNC(SYSDATE))
          ELSE
            CASE NVL(P.IDUTDTPROCTNFE,'N')
              WHEN 'S'
              THEN
                CASE TP.IDTPTRANSNFE
                  WHEN 'F'
                  THEN N.DTEMISSAO
                  ELSE NVL(N.DTEMISSAO,
                    CASE
                      WHEN N.DTENTRSAID > TRUNC(SYSDATE)
                      THEN TRUNC(SYSDATE)
                      ELSE N.DTENTRSAID
                    END)
                END
              ELSE NVL(N.DTEMISSAO,
                CASE
                  WHEN N.DTENTRSAID > TRUNC (SYSDATE)
                  THEN TRUNC(SYSDATE)
                  ELSE N.DTENTRSAID
                END)
            END
        END AS DTEMISSAO
        from PARAMGERAL P, NOTAFISCAL N, TIPOOPERAC TP
        WHERE N.NRLANCTONF = :P_NRLANCTONF
        AND N.CDFILIAL = :P_CDFILIAL
        AND N.CDTIPOOPER = TP.CDTIPOOPER
        AND N.IDENTRSAIDOP = TP.IDENTRSAIDOP
SQL;
    
        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }
    
    public function getCertificado($ie, $cnpj, $cdEmpresa) {
        $sql = "SELECT DSDIRCERTIFICADO, CDSENHACERTIF FROM INSCRESTAD WHERE CDINSCESTA = :CDINSCESTA AND CDEMPRESA = :CDEMPRESA AND DSDIRCERTIFICADO IS NOT NULL";

        $params = array("CDINSCESTA"      => $ie,
                        "CDEMPRESA"       => $cdEmpresa);
					
		$std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getInfoPagamento($cdfilial, $nrlanctonf) {
        $sql = "SELECT I.CDFILIAL,
                  I.NRLANCTONF,
                  I.NRSEQINFOPAGANFE,
                  I.IDTPINTPAGACARD,
                  I.NRINSJURCREDCARD,
                  I.IDTPBANDCARD,
                  I.NRAUTOOPERACARD,
                  I.VRPAGAMENTO,
                  I.IDTPMEIOPAGA,
                  I.IDTPFORMAPAGA,
                  DECODE(SUBSTR(LTRIM(TO_CHAR(ROUND(I.VRPAGAMENTO, 2), '999999999999.99')), 1, 1), '.', '0'
                  ||LTRIM(TO_CHAR(ROUND(I.VRPAGAMENTO, 2), '9999999999999.99')), LTRIM(TO_CHAR(ROUND(I.VRPAGAMENTO, 2), '9999999999999.99'))) AS VALORPAGAMENTO
                FROM NOTAFISCAL N
                JOIN INFOPAGANFE I
                ON (I.CDFILIAL    = N.CDFILIAL)
                AND (I.NRLANCTONF = N.NRLANCTONF)
                WHERE N.CDFILIAL  = :P_CDFILIAL
                AND N.NRLANCTONF  = :P_NRLANCTONF
                ORDER BY I.NRSEQINFOPAGANFE";
        
        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);
    }
    
    public function impostoTrib($cdfilial, $nrlanctonf) {
        $sql = "SELECT II.CDFILIAL, II.NRLANCTONF, II.CDIMPOSTO
                FROM ITEMPROIMPOS II, IMPOSTO I
               WHERE II.CDFILIAL = :P_CDFILIAL
                 AND II.NRLANCTONF = :P_NRLANCTONF
                 AND II.CDIMPOSTO = I.CDIMPOSTRIB";
                 
        $params = array(
            "P_NRLANCTONF" => $nrlanctonf,
            "P_CDFILIAL"   => $cdfilial
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);         
                 
    }
    
    public function updateNotaOl($nrnotafisc, $dtemissao, $dsnotaorig) {
        $sql = "UPDATE NOTAFISCAL
                SET NRNOTAFISC = :NRNOTAFISC,
                DTEMISSAO = :DTEMISSAO
                WHERE DSNOTAFISORIGOL = :DSNOTAFISORIGOL";
                
        $params = array(
            "NRNOTAFISC"  => $nrnotafisc,
            "DTEMISSAO"   => $dtemissao,
            "DSNOTAFISORIGOL"  => $dsnotaorig
        );
                
        $std = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateNotaReplicada($dtemissao, $nrnotafisc, $iddocreplic, $cdfilirece, $cdfiliemit) {
        $sql = "UPDATE NOTAFISCAL
                SET DTEMISSAO  = :DTEMISSAO,
                NRNOTAFISC = :NRNOTAFISC
                WHERE IDDOCREPLIC = :IDDOCREPLIC
                AND CDFILIAL || NRLANCTONF <> :IDDOCREPLIC
                AND CDFILIRECE = :CDFILIRECE
                AND CDFILIEMIT = :CDFILIEMIT
                AND IDENTRSAIDOP = 'E'";
        
         $params = array(
            "DTEMISSAO"   => $dtemissao,
            "NRNOTAFISC"  => $nrnotafisc,
            "IDDOCREPLIC" => $iddocreplic,
            "CDFILIRECE"  => $cdfilirece,
            "CDFILIEMIT"  => $cdfiliemit
        );
                
        $std = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);
    }
    
    public function getGeraInfoPagamento($cdfilial, $nrlanctonf) {
        $sql = "SELECT NVL(C.VRORIG, N.VRNOTAFISC) AS VRORIG,
                NVL(C.DTORIGVEN, N.DTENTRSAID) AS DTORIGVEN
                FROM NOTAFISCAL N,
                (SELECT CDFILIAL, 
                        NRLANCTONF, 
                        SUM(VRORIGREC) AS VRORIG, 
                        MAX(DTORIGVENREC) AS DTORIGVEN
                FROM CONTARECEBER
                WHERE CDFILIAL = :P_CDFILIAL
                    AND NRLANCTONF = :P_NRLANCTONF
                GROUP BY CDFILIAL,
                        NRLANCTONF
                UNION ALL
                SELECT CDFILIAL, 
                        NRLANCTONF, 
                        SUM(VRORIGPAG) AS VRORIG, 
                        MAX(DTORIGVENPAG) AS DTORIGVEN
                FROM CONTAPAGAR
                WHERE CDFILIAL = :P_CDFILIAL
                    AND NRLANCTONF = :P_NRLANCTONF
                GROUP BY CDFILIAL,
                        NRLANCTONF) C
                WHERE N.CDFILIAL = C.CDFILIAL
                AND N.NRLANCTONF = C.NRLANCTONF";
                
        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF"  => $nrlanctonf
        );

        return $this->entityManager->getConnection()->fetchAll($sql, $params);     
    }
    
    public function verificaNotaDevo($cdfilial, $nrlanctonf) {
        $sql = "SELECT ITE.NRLANCTONF,
                  ITE.CDFILIAL
                FROM ITEMNOTAFISC ITE
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF";
                
        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF"  => $nrlanctonf
        );
                
        $resul = $this->entityManager->getConnection()->fetchAll($sql, $params);       
        
        return empty($resul) ? 'N' : 'S';
    }
    
    public function insereInfoPagaNfe($cdfilial, $nrlanctonf, $nrSeqInfo, $idTpFormaPaga, $vrPagamento, $idTpMeioPaga, $nrOrg) {
        $sql = "INSERT
                INTO INFOPAGANFE
                  (
                    CDFILIAL,
                    NRLANCTONF,
                    NRSEQINFOPAGANFE,
                    IDTPFORMAPAGA,
                    VRPAGAMENTO,
                    IDTPMEIOPAGA,
                    NRORG
                  )
                  VALUES
                  (
                    :P_CDFILIAL,
                    :P_NRLANCTONF,
                    :P_NRSEQINFOPAGANFE,
                    :P_IDTPFORMAPAGA,
                    :P_VRPAGAMENTO,
                    :P_IDTPMEIOPAGA,
                    :P_NRORG
                  )";
                  
        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF"  => $nrlanctonf,
            "P_NRSEQINFOPAGANFE" => $nrSeqInfo,
            "P_IDTPFORMAPAGA"    => $idTpFormaPaga,
            "P_VRPAGAMENTO"      => $vrPagamento,
            "P_IDTPMEIOPAGA"     => $idTpMeioPaga,
            "P_NRORG"            => $nrOrg
        );
        
        $std   = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);      
        
    }
    
    public function getXMLEnvio($cdfilial, $nrlanctonf, $idtipoarqxml) {
        $sql = "SELECT A.DSARQXMLNFE, A.DSARQXMLNFE_CLOB FROM ARQXMLNFE A
                WHERE A.CDFILIAL = :P_CDFILIAL
                AND A.NRLANCTONF = :P_NRLANCTONF
                AND A.IDTIPOARQXML = :P_IDTIPOARQXML";
                
        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRLANCTONF"  => $nrlanctonf,
            "P_IDTIPOARQXML" => $idtipoarqxml);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    }
    
    public function getLogoEmpresa($cdEmpresa) {
        $sql = "SELECT DSDIRLOGOMARCA FROM EMPRESA WHERE CDEMPRESA = :P_CDEMPRESA";
        
        $params = array(
            "P_CDEMPRESA"   => $cdEmpresa);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    }
    
    public function getMensagemEmpresa($cdEmpresa) {
        $sql = "SELECT DSMENSEMAILNFE, DSMENSEMAILCCE, DSMENSEMAILCANC FROM EMPRESA WHERE CDEMPRESA = :P_CDEMPRESA";
        
        $params = array(
            "P_CDEMPRESA"   => $cdEmpresa);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    } 
    
    public function utilizaEmailTransmissao($cdEmpresa) {
        $sql = "SELECT IDEMAILNFTRANS FROM PARAMEMPRESA WHERE CDEMPRESA = :P_CDEMPRESA";
        
         $params = array(
            "P_CDEMPRESA"   => $cdEmpresa);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    }
    
    public function getClienteNota($nrAcessoNfe) {
        $sql = "SELECT C.NMRAZSOCCLIE FROM NOTAFISCAL N, CLIENTE C 
                WHERE N.NRACESSONFE = :P_NRACESSONFE
                AND   N.CDCLIENTE   = C.CDCLIENTE";
        
         $params = array(
            "P_NRACESSONFE"   => $nrAcessoNfe);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    }
    
    public function getOrganizacao($nrOrg) {
        $sql = "SELECT NMORGANIZACAO FROM ORGANIZACAO WHERE NRORG = :P_NRORG";
        
        $params = array("P_NRORG"   => $nrOrg);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetch();  
    }
    
    public function verificaTipoOperac($cdtipooper, $cdfilial, $identrsaidop) {
        $sql = "SELECT * FROM PARAMBLOQNFAFIL PB
                WHERE PB.CDTIPOOPER = :P_CDTIPOOPER
                AND PB.CDFILIAL     = :P_CDFILIAL
                AND PB.IDENTRSAIDOP = :P_IDENTRSAIDOP";
                
        $params = array("P_CDTIPOOPER"   => $cdtipooper,
                        "P_CDFILIAL"     => $cdfilial,
                        "P_IDENTRSAIDOP" => $identrsaidop);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    }
    
    public function getInscricoesAutorizadas($cdempresa, $cdinscesta) {
        $sql = "SELECT DISTINCT NRINSJURAUTOXML FROM AUTOOBTERXMLGER
                UNION
                SELECT DISTINCT NRINSJURAUTOXML
                FROM AUTOOBTERXMLIE
                WHERE CDEMPRESA = :P_CDEMPRESA
                AND CDINSCESTA  = :P_CDINSCESTA";
                
        $params = array("P_CDEMPRESA"   => $cdempresa,
                        "P_CDINSCESTA"     => $cdinscesta);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetchAll();  
    }
    
    public function insereXmlCancelado($cdfilial, $nrlanctonf, $novoCdfilial, $novoNrlanctonf) {
        $sql = "INSERT
                INTO ARQXMLNFE
                  (
                    CDFILIAL,
                    NRLANCTONF,
                    IDTIPOARQXML,
                    NRORG
                  )
                  SELECT :P_NOVOCDFILIAL,
                      :P_NOVONRLANCTONF,
                      IDTIPOARQXML,
                      NRORG
                    FROM ARQXMLNFE
                    WHERE CDFILIAL = :P_CDFILIAL
                    AND NRLANCTONF = :P_NRLANCONF";
     
        $params = array("P_CDFILIAL"      => $cdfilial,
                        "P_NRLANCONF"     => $nrlanctonf,
                        "P_NOVOCDFILIAL"  => $novoCdfilial,
                        "P_NOVONRLANCTONF" => $novoNrlanctonf);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);               
    }
    
    public function removeXmlCancelado($cdfilial, $nrlanctonf) {
         $sql = "DELETE FROM ARQXMLNFE
                    WHERE CDFILIAL = :P_CDFILIAL
                    AND NRLANCTONF = :P_NRLANCONF";
     
        $params = array("P_CDFILIAL"      => $cdfilial,
                        "P_NRLANCONF"     => $nrlanctonf);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);               
    }
    
    
    public function utilizaAprovacaoAutomatica($connection, $cdempresa, $nrorg) {
        $sql = "SELECT IDAPROVNFTRANS
                  FROM PARAMEMPRESA
                 WHERE CDEMPRESA  = :CDEMPRESA
                   AND NRORG      = :NRORG";

        $params = array(
            "CDEMPRESA" => $cdempresa,
            "NRORG" => $nrorg
        );

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        $dataset = $std->fetchAll();

        return (count($dataset) > 0) ? $dataset[0]["IDAPROVNFTRANS"] : null;
    }
    
    public function getCBenefItem($cdfilial, $nrlanctonf, $nrseqitprod) {
        $sql = "SELECT CDBENEFFISCAL FROM ITEMPROIMPOS IT, IMPOSTO I 
            WHERE IT.CDIMPOSTO = I.CDIMPOSTO
            AND I.CDIMPOSTONFE = '00'
            AND IT.CDFILIAL = :P_CDFILIAL
            AND IT.NRLANCTONF = :P_NRLANCTONF
            AND IT.NRSEQITPROD = :P_NRSEQITPROD";  
            
        $params = array(
            "P_CDFILIAL"        => $cdfilial,
            "P_NRLANCTONF"      => $nrlanctonf,
            "P_NRSEQITPROD"     => $nrseqitprod
        );
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
		return $std->fetch();  
    }
    
    public function getProdFiliTrans($cdfilial, $cdproduto) {
        $sql = "SELECT NVL(PF.IDCNTRESTOQ, 'S') AS IDCNTRESTOQ,
                     NVL(PF.IDUTCTRLLOTE, 'S') AS IDUTCTRLLOTE,
                     NVL(PF.IDPRODCOMRASTRO, 'N') AS IDPRODCOMRASTRO
                FROM PRODFILI PF
               WHERE CDFILIAL = :P_CDFILIAL
                 AND CDPRODUTO = :P_CDPRODUTO";
         
        $params = array(
            "P_CDFILIAL"    => $cdfilial,
            "P_CDPRODUTO"   => $cdproduto
        );
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

		return $std->fetch(); 
    }
    
    public function getTipoOperTrans($cdtipooper, $identrsaidop) {
        $sql = "SELECT NVL(IDTPTRANSNFE, 'N') AS IDTPTRANSNFE,
                       NVL(IDUTILVENC,  'N') AS IDUTILVENC,
                       NVL(IDATUESTTPOP, 'N') AS IDATUESTTPOP
                  FROM TIPOOPERAC TP
                 WHERE TP.CDTIPOOPER = :P_CDTIPOOPER
                   AND TP.IDENTRSAIDOP = :P_IDENTRSAIDOP";
        
        $params = array(
            "P_CDTIPOOPER"      => $cdtipooper,
            "P_IDENTRSAIDOP"    => $identrsaidop
        );
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        
        return $std->fetch();
    }
    
    public function getDiretorioLogo($nrlanctonf, $cdfilial) {
        $sql = "SELECT E.DSDIRLOGOMARCA 
                FROM EMPRESA E, FILIAL F, 
                    ( SELECT N.CDEMPRESA, N.CDFILIAL 
                      FROM NOTAFISCAL N 
                      WHERE N.NRLANCTONF = :P_NRLANCTONF
                    AND N.CDFILIAL = :P_CDFILIAL) N
                WHERE E.CDEMPRESA = N.CDEMPRESA
                AND F.CDFILIAL = N.CDFILIAL";
        $params   = array (
			"P_NRLANCTONF" => $nrlanctonf,
			"P_CDFILIAL" => $cdfilial
		);  
           
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();  
    }
    
    public function getDadosAdic($cdfilial, $nrlacntonf) {
        $sql = <<<SQL
                SELECT NRDADOADIC, CDMENSAGEM, DSDADOADIC
                FROM DADOSADIC
                WHERE CDFILIAL = :P_CDFILIAL
                AND NRLANCTONF = :P_NRLANCTONF
                ORDER BY NRDADOADIC
             
SQL;
            
        $params = array (
            "P_CDFILIAL" => $cdfilial,
            "P_NRLANCTONF" => $nrlacntonf
        );
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();  
    }
    
    public function atualizaCCeDuplicidade ($cdfilial, $nrlanctonf) {
        $sql = "UPDATE CARTACORNFE
                   SET NRSEQCCE = LPAD(TO_CHAR((SELECT MAX(TO_NUMBER(NRSEQCCE)) + 1
                                                  FROM CARTACORNFE
                                                 WHERE CDFILIAL   = :P_CDFILIAL
                                                   AND NRLANCTONF = :P_NRLANCTONF)), 2, '0')
                 WHERE CDFILIAL   = :P_CDFILIAL
                   AND NRLANCTONF = :P_NRLANCTONF
                   AND TO_NUMBER(NRSEQCCE) = (SELECT MAX(TO_NUMBER(NRSEQCCE))
                                                FROM CARTACORNFE
                                               WHERE CDFILIAL   = :P_CDFILIAL
                                                 AND NRLANCTONF = :P_NRLANCTONF)";
        $params = array(
            "P_CDFILIAL"  => $cdfilial,
            "P_NRLANCTONF"   => $nrlanctonf
        );
                
        $std = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);
    }
    
    public function getEmailsAdic ($idOrigem, $valueCampoPK, $idtpijurtran = null) {
        $condicao = null;
        
        if     ($idOrigem === 'C') $condicao = 'CDCLIENTE         = :P_VALUECAMPOPK';
        else if($idOrigem === 'F') $condicao = 'CDFORNECED        = :P_VALUECAMPOPK';
        else if($idOrigem === 'L') $condicao = 'CDFILIAL          = :P_VALUECAMPOPK';
        else if($idOrigem === 'T') $condicao = 'NRINSJURTRAN      = :P_VALUECAMPOPK
                                                AND IDTPIJURTRAN  = :P_IDTPIJURTRAN';
        
        $sql = 'SELECT LOWER(DSEMAIL) AS DSEMAIL
                  FROM EMAILADICIONAIS
                 WHERE IDORIGEM = :P_IDORIGEM
                   AND '.$condicao;
        
        $params = $idOrigem != 'T' ? array ("P_IDORIGEM" => $idOrigem, "P_VALUECAMPOPK" => $valueCampoPK)
                                   : array ("P_IDORIGEM" => $idOrigem, "P_VALUECAMPOPK" => $valueCampoPK, "P_IDTPIJURTRAN" => $idtpijurtran);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function getEndEntrega($cdfilial, $nrlanctonf) {
        $sql = <<<SQL
         SELECT F.NRINSJURFILI AS CNPJCPF, E.DSENDEFILI AS LOGRADOURO, '.' AS NUMERO, E.DSCOMPENDFIL AS COMPLEMENTO, E.NMBAIRFILI AS BAIRRO,
                M.CDMUNICIBGE AS CDIBGEMUNI, M.NMMUNICIPIO AS MUNICIPIO, E.SGESTADO AS UF, S.CDESTADOIBGE, E.NRCEPFILI AS NRCEP,
                P.CDPAISBACEN, P.NMPAIS, E.NRTELEFILI AS NRTELEFONE, E.DSEMAILFILI AS EMAIL
         FROM NOTAFISCAL N INNER JOIN ENDEFILI E  ON (CASE WHEN N.IDENTRSAIDOP = 'S' THEN N.CDFILIRECE ELSE N.CDFILIEMIT END) = E.CDFILIAL
                           INNER JOIN PAIS P      ON (E.CDPAIS       = P.CDPAIS)
                           INNER JOIN FILIAL F    ON  E.CDFILIAL     = F.CDFILIAL
                           INNER JOIN ESTADO S    ON (E.CDPAIS       = S.CDPAIS)
                                                 AND (E.SGESTADO     = S.SGESTADO)
                           INNER JOIN MUNICIPIO M ON  E.CDMUNICIPIO  = M.CDMUNICIPIO
                                                  AND E.CDPAIS       = M.CDPAIS
                                                  AND E.SGESTADO     = M.SGESTADO
         WHERE N.CDFILIAL     = :P_CDFILIAL
           AND N.NRLANCTONF   = :P_NRLANCTONF
           AND N.IDORIGDESTNF = 'L'
           AND E.IDTPENDEFILI = 'T'
           AND E.IDATIVO      = 'S'
        
        UNION ALL
        
         SELECT C.NRINSJURCLIE AS CNPJCPF, E.DSENDECLIE AS LOGRADOURO, '.' AS NUMERO, E.DSCOMPENDCLI AS COMPLEMENTO, E.NMBAIRCLIE AS BAIRRO,
                M.CDMUNICIBGE AS CDIBGEMUNI, M.NMMUNICIPIO AS MUNICIPIO, E.SGESTADO AS UF, S.CDESTADOIBGE, E.NRCEPCLIE AS NRCEP,
                P.CDPAISBACEN, P.NMPAIS, E.NRTELECLIE AS NRTELEFONE, E.DSEMAILCLIENFE AS EMAIL
         FROM NOTAFISCAL N INNER JOIN ENDECLIE E  ON  N.CDCLIENTE    = E.CDCLIENTE
                           INNER JOIN PAIS P      ON (E.CDPAIS       = P.CDPAIS)
                           INNER JOIN CLIENTE C   ON  E.CDCLIENTE    = C.CDCLIENTE
                           INNER JOIN ESTADO S    ON (E.CDPAIS       = S.CDPAIS)
                                                 AND (E.SGESTADO     = S.SGESTADO)
                           INNER JOIN MUNICIPIO M ON  E.CDMUNICIPIO  = M.CDMUNICIPIO
                                                 AND  E.CDPAIS       = M.CDPAIS
                                                 AND  E.SGESTADO     = M.SGESTADO
         WHERE N.CDFILIAL     = :P_CDFILIAL
           AND N.NRLANCTONF   = :P_NRLANCTONF
           AND E.IDTPENDECLIE = 'T'
           AND E.IDATIVO      = 'S'
        
        UNION ALL
        
         SELECT F.NRINSJURFORN AS CNPJCPF, E.DSENDEFORN AS LOGRADOURO, '.' AS NUMERO, E.DSCOMPENDFOR AS COMPLEMENTO, E.NMBAIRFORN AS BAIRRO, 
                M.CDMUNICIBGE AS CDIBGEMUNI, M.NMMUNICIPIO AS MUNICIPIO, E.SGESTADO AS UF, S.CDESTADOIBGE, E.NRCEPFORN AS NRCEP,
                P.CDPAISBACEN, P.NMPAIS, E.NRTELEFORN AS NRTELEFONE, E.DSEMAILFORNNFE AS EMAIL
         FROM NOTAFISCAL N INNER JOIN ENDEFORN E   ON  N.CDFORNECED   = E.CDFORNECED
                           INNER JOIN PAIS P       ON (E.CDPAIS       = P.CDPAIS)
                           INNER JOIN FORNECEDOR F ON  E.CDFORNECED   = F.CDFORNECED
                           INNER JOIN ESTADO S     ON (E.CDPAIS       = S.CDPAIS)
                                                  AND (E.SGESTADO     = S.SGESTADO)
                           INNER JOIN MUNICIPIO M  ON  E.CDMUNICIPIO  = M.CDMUNICIPIO
                                                  AND  E.CDPAIS       = M.CDPAIS
                                                  AND  E.SGESTADO     = M.SGESTADO
         WHERE N.CDFILIAL     = :P_CDFILIAL
           AND N.NRLANCTONF   = :P_NRLANCTONF
           AND E.IDTPENDEFORN = 'T'
           AND E.IDATIVO      = 'S'
SQL;
    
        $params = array ("P_CDFILIAL" => $cdfilial, "P_NRLANCTONF" => $nrlanctonf);
            
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        
        return $std->fetch();
    }
    
    public function getNFPedido($cdfilial, $nrlanctonf) {
        $sql = "SELECT DISTINCT CDFILIALPED, NRPEDIDO
                  FROM ITEMPRODUTO
                 WHERE (CDFILIAL   = :P_CDFILIAL  )
                   AND (NRLANCTONF = :P_NRLANCTONF)
                 ORDER BY CDFILIALPED, NRPEDIDO";
        
        $params = array ("P_CDFILIAL" => $cdfilial, "P_NRLANCTONF" => $nrlanctonf);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getEndPedido($cdfilial, $nrpedido) {
        $sql = "SELECT CDFILIAL, NRPEDIDO, NMRAZSOCPED, DSENDEPED, NRCEPPED, NRTELEPED,
                       NRINSJURPED, NRINSESTPED, NMPAISPED, SGESTADOPED, NMMUNIPED, NMBAIRROPED,
                       CDPAISPED, NMESTADOPED, CDMUNICIPIOPED, ES.CDESTADOIBGE, MU.CDMUNICIBGE,
                       PA.CDPAISBACEN, C.IDTPIJURCLIE, C.NRINSJURCLIE
                  FROM DADOSENDPED DE, PAIS PA, ESTADO ES, MUNICIPIO MU, CLIENTE C
                 WHERE (DE.CDFILIAL       = :P_CDFILIAL   )
                   AND (DE.NRPEDIDO       = :P_NRPEDIDO   )
                   AND (DE.CDPAISPED      = ES.CDPAIS     ) 
                   AND (DE.SGESTADOPED    = ES.SGESTADO   ) 
                   AND (DE.CDPAISPED      = MU.CDPAIS     ) 
                   AND (DE.SGESTADOPED    = MU.SGESTADO   ) 
                   AND (DE.CDMUNICIPIOPED = MU.CDMUNICIPIO) 
                   AND (DE.CDPAISPED      = PA.CDPAIS     )
                   AND (DE.CDCLIENTE      = C.CDCLIENTE   )
                   AND (DE.IDTPENDECLIE  <> C.IDENDEMISCLI)
                 ORDER BY DE.CDFILIAL, DE.NRPEDIDO";
                 
        $params = array ("P_CDFILIAL" => $cdfilial, "P_NRPEDIDO" => $nrpedido);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function getEndFilial ($cdfiliemit) {
        $sql = "SELECT
                 EF.DSENDEFILI,
                 EF.DSENDEFILISEP,
                 EF.NRENDEFILISEP,
                 EF.DSCOMPENDFIL,
                 EF.NMBAIRFILI,
                 MEC.CDMUNICIBGE,
                 E.CDESTADOIBGE,
                 MEC.NMMUNICIPIO,
                 E.SGESTADO,
                 EF.NRCEPFILI,
                 P.CDPAISBACEN,
                 P.NMPAIS,
                 EF.NRTELEFILI,
                 F.IDENDEMISFIL,     
                 EF.DSEMAILFILI
             FROM
                 FILIAL F,
                 ENDEFILI EF,
                 MUNICIPIO MEC,
                 BAIRRO B,
                 PAIS P,
                 ESTADO E
             WHERE
                     ( F.CDFILIAL           = EF.CDFILIAL (+) )
                 AND ( EF.IDTPENDEFILI      = 'P' )
                 AND ( EF.CDPAIS            = MEC.CDPAIS (+) )
                 AND ( EF.SGESTADO          = MEC.SGESTADO (+) )
                 AND ( EF.CDMUNICIPIO       = MEC.CDMUNICIPIO (+) )
                 AND ( B.CDPAIS (+)         = EF.CDPAIS )
                 AND ( B.SGESTADO (+)       = EF.SGESTADO )
                 AND ( B.CDMUNICIPIO (+)    = EF.CDMUNICIPIO )
                 AND ( B.CDBAIRRO (+)       = EF.CDBAIRRO )
                 AND ( P.CDPAIS             = EF.CDPAIS )
                 AND ( E.SGESTADO           = EF.SGESTADO )
                 AND ( F.CDFILIAL           = :P_CDFILIAL )";
        
        $params = array ("P_CDFILIAL" => $cdfiliemit);
        
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function atualizaXMLNT2020006 () { // Remover esta function após 01/09/2021 e atualizar as chamadas na XmlNFeService.
        $sql = "SELECT CASE 
                        WHEN TRUNC(SYSDATE) >= TRUNC(DTINIVIGENCIAPROD) THEN 1
                        ELSE 0
                       END AS ATUALIZAPROD,
                       CASE 
                        WHEN TRUNC(SYSDATE) >= TRUNC(DTINIVIGENCIAHOMO) THEN 1
                        ELSE 0
                       END AS ATUALIZAHOMOLOG
                  FROM HISTALTERADFE
                 WHERE CDPROCESSO = 'NF'
                   AND CDNOTATECNICA = '2020006'
                   AND CDVERSAONT = '1.20'";
                   
        return $std = $this->entityManager->getConnection()->fetchAssoc($sql);
    }
}